// Code generated by go-swagger; DO NOT EDIT.

package admin

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewAdminCreateOrgParams creates a new AdminCreateOrgParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAdminCreateOrgParams() *AdminCreateOrgParams {
	return &AdminCreateOrgParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAdminCreateOrgParamsWithTimeout creates a new AdminCreateOrgParams object
// with the ability to set a timeout on a request.
func NewAdminCreateOrgParamsWithTimeout(timeout time.Duration) *AdminCreateOrgParams {
	return &AdminCreateOrgParams{
		timeout: timeout,
	}
}

// NewAdminCreateOrgParamsWithContext creates a new AdminCreateOrgParams object
// with the ability to set a context for a request.
func NewAdminCreateOrgParamsWithContext(ctx context.Context) *AdminCreateOrgParams {
	return &AdminCreateOrgParams{
		Context: ctx,
	}
}

// NewAdminCreateOrgParamsWithHTTPClient creates a new AdminCreateOrgParams object
// with the ability to set a custom HTTPClient for a request.
func NewAdminCreateOrgParamsWithHTTPClient(client *http.Client) *AdminCreateOrgParams {
	return &AdminCreateOrgParams{
		HTTPClient: client,
	}
}

/*
AdminCreateOrgParams contains all the parameters to send to the API endpoint

	for the admin create org operation.

	Typically these are written to a http.Request.
*/
type AdminCreateOrgParams struct {

	// Organization.
	Organization *models.CreateOrgOption

	/* Username.

	   username of the user that will own the created organization
	*/
	Username string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the admin create org params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminCreateOrgParams) WithDefaults() *AdminCreateOrgParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the admin create org params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminCreateOrgParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the admin create org params
func (o *AdminCreateOrgParams) WithTimeout(timeout time.Duration) *AdminCreateOrgParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the admin create org params
func (o *AdminCreateOrgParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the admin create org params
func (o *AdminCreateOrgParams) WithContext(ctx context.Context) *AdminCreateOrgParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the admin create org params
func (o *AdminCreateOrgParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the admin create org params
func (o *AdminCreateOrgParams) WithHTTPClient(client *http.Client) *AdminCreateOrgParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the admin create org params
func (o *AdminCreateOrgParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrganization adds the organization to the admin create org params
func (o *AdminCreateOrgParams) WithOrganization(organization *models.CreateOrgOption) *AdminCreateOrgParams {
	o.SetOrganization(organization)
	return o
}

// SetOrganization adds the organization to the admin create org params
func (o *AdminCreateOrgParams) SetOrganization(organization *models.CreateOrgOption) {
	o.Organization = organization
}

// WithUsername adds the username to the admin create org params
func (o *AdminCreateOrgParams) WithUsername(username string) *AdminCreateOrgParams {
	o.SetUsername(username)
	return o
}

// SetUsername adds the username to the admin create org params
func (o *AdminCreateOrgParams) SetUsername(username string) {
	o.Username = username
}

// WriteToRequest writes these params to a swagger request
func (o *AdminCreateOrgParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Organization != nil {
		if err := r.SetBodyParam(o.Organization); err != nil {
			return err
		}
	}

	// path param username
	if err := r.SetPathParam("username", o.Username); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
