// Code generated by go-swagger; DO NOT EDIT.

package admin

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewAdminEditHookParams creates a new AdminEditHookParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAdminEditHookParams() *AdminEditHookParams {
	return &AdminEditHookParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAdminEditHookParamsWithTimeout creates a new AdminEditHookParams object
// with the ability to set a timeout on a request.
func NewAdminEditHookParamsWithTimeout(timeout time.Duration) *AdminEditHookParams {
	return &AdminEditHookParams{
		timeout: timeout,
	}
}

// NewAdminEditHookParamsWithContext creates a new AdminEditHookParams object
// with the ability to set a context for a request.
func NewAdminEditHookParamsWithContext(ctx context.Context) *AdminEditHookParams {
	return &AdminEditHookParams{
		Context: ctx,
	}
}

// NewAdminEditHookParamsWithHTTPClient creates a new AdminEditHookParams object
// with the ability to set a custom HTTPClient for a request.
func NewAdminEditHookParamsWithHTTPClient(client *http.Client) *AdminEditHookParams {
	return &AdminEditHookParams{
		HTTPClient: client,
	}
}

/*
AdminEditHookParams contains all the parameters to send to the API endpoint

	for the admin edit hook operation.

	Typically these are written to a http.Request.
*/
type AdminEditHookParams struct {

	// Body.
	Body *models.EditHookOption

	/* ID.

	   id of the hook to update

	   Format: int64
	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the admin edit hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminEditHookParams) WithDefaults() *AdminEditHookParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the admin edit hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AdminEditHookParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the admin edit hook params
func (o *AdminEditHookParams) WithTimeout(timeout time.Duration) *AdminEditHookParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the admin edit hook params
func (o *AdminEditHookParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the admin edit hook params
func (o *AdminEditHookParams) WithContext(ctx context.Context) *AdminEditHookParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the admin edit hook params
func (o *AdminEditHookParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the admin edit hook params
func (o *AdminEditHookParams) WithHTTPClient(client *http.Client) *AdminEditHookParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the admin edit hook params
func (o *AdminEditHookParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the admin edit hook params
func (o *AdminEditHookParams) WithBody(body *models.EditHookOption) *AdminEditHookParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the admin edit hook params
func (o *AdminEditHookParams) SetBody(body *models.EditHookOption) {
	o.Body = body
}

// WithID adds the id to the admin edit hook params
func (o *AdminEditHookParams) WithID(id int64) *AdminEditHookParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the admin edit hook params
func (o *AdminEditHookParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *AdminEditHookParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
