// Code generated by go-swagger; DO NOT EDIT.

package client

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/client/activitypub"
	"src.opensuse.org/autogits/common/gitea-generated/client/admin"
	"src.opensuse.org/autogits/common/gitea-generated/client/issue"
	"src.opensuse.org/autogits/common/gitea-generated/client/miscellaneous"
	"src.opensuse.org/autogits/common/gitea-generated/client/notification"
	"src.opensuse.org/autogits/common/gitea-generated/client/organization"
	"src.opensuse.org/autogits/common/gitea-generated/client/package_operations"
	"src.opensuse.org/autogits/common/gitea-generated/client/repository"
	"src.opensuse.org/autogits/common/gitea-generated/client/settings"
	"src.opensuse.org/autogits/common/gitea-generated/client/user"
)

// Default gitea API HTTP client.
var Default = NewHTTPClient(nil)

const (
	// DefaultHost is the default Host
	// found in Meta (info) section of spec file
	DefaultHost string = "localhost"
	// DefaultBasePath is the default BasePath
	// found in Meta (info) section of spec file
	DefaultBasePath string = "/api/v1"
)

// DefaultSchemes are the default schemes found in Meta (info) section of spec file
var DefaultSchemes = []string{"http", "https"}

// NewHTTPClient creates a new gitea API HTTP client.
func NewHTTPClient(formats strfmt.Registry) *GiteaAPI {
	return NewHTTPClientWithConfig(formats, nil)
}

// NewHTTPClientWithConfig creates a new gitea API HTTP client,
// using a customizable transport config.
func NewHTTPClientWithConfig(formats strfmt.Registry, cfg *TransportConfig) *GiteaAPI {
	// ensure nullable parameters have default
	if cfg == nil {
		cfg = DefaultTransportConfig()
	}

	// create transport and client
	transport := httptransport.New(cfg.Host, cfg.BasePath, cfg.Schemes)
	return New(transport, formats)
}

// New creates a new gitea API client
func New(transport runtime.ClientTransport, formats strfmt.Registry) *GiteaAPI {
	// ensure nullable parameters have default
	if formats == nil {
		formats = strfmt.Default
	}

	cli := new(GiteaAPI)
	cli.Transport = transport
	cli.Activitypub = activitypub.New(transport, formats)
	cli.Admin = admin.New(transport, formats)
	cli.Issue = issue.New(transport, formats)
	cli.Miscellaneous = miscellaneous.New(transport, formats)
	cli.Notification = notification.New(transport, formats)
	cli.Organization = organization.New(transport, formats)
	cli.PackageOperations = package_operations.New(transport, formats)
	cli.Repository = repository.New(transport, formats)
	cli.Settings = settings.New(transport, formats)
	cli.User = user.New(transport, formats)
	return cli
}

// DefaultTransportConfig creates a TransportConfig with the
// default settings taken from the meta section of the spec file.
func DefaultTransportConfig() *TransportConfig {
	return &TransportConfig{
		Host:     DefaultHost,
		BasePath: DefaultBasePath,
		Schemes:  DefaultSchemes,
	}
}

// TransportConfig contains the transport related info,
// found in the meta section of the spec file.
type TransportConfig struct {
	Host     string
	BasePath string
	Schemes  []string
}

// WithHost overrides the default host,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithHost(host string) *TransportConfig {
	cfg.Host = host
	return cfg
}

// WithBasePath overrides the default basePath,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithBasePath(basePath string) *TransportConfig {
	cfg.BasePath = basePath
	return cfg
}

// WithSchemes overrides the default schemes,
// provided by the meta section of the spec file.
func (cfg *TransportConfig) WithSchemes(schemes []string) *TransportConfig {
	cfg.Schemes = schemes
	return cfg
}

// GiteaAPI is a client for gitea API
type GiteaAPI struct {
	Activitypub activitypub.ClientService

	Admin admin.ClientService

	Issue issue.ClientService

	Miscellaneous miscellaneous.ClientService

	Notification notification.ClientService

	Organization organization.ClientService

	PackageOperations package_operations.ClientService

	Repository repository.ClientService

	Settings settings.ClientService

	User user.ClientService

	Transport runtime.ClientTransport
}

// SetTransport changes the transport on the client and all its subresources
func (c *GiteaAPI) SetTransport(transport runtime.ClientTransport) {
	c.Transport = transport
	c.Activitypub.SetTransport(transport)
	c.Admin.SetTransport(transport)
	c.Issue.SetTransport(transport)
	c.Miscellaneous.SetTransport(transport)
	c.Notification.SetTransport(transport)
	c.Organization.SetTransport(transport)
	c.PackageOperations.SetTransport(transport)
	c.Repository.SetTransport(transport)
	c.Settings.SetTransport(transport)
	c.User.SetTransport(transport)
}
