// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueDeleteStopWatchParams creates a new IssueDeleteStopWatchParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueDeleteStopWatchParams() *IssueDeleteStopWatchParams {
	return &IssueDeleteStopWatchParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueDeleteStopWatchParamsWithTimeout creates a new IssueDeleteStopWatchParams object
// with the ability to set a timeout on a request.
func NewIssueDeleteStopWatchParamsWithTimeout(timeout time.Duration) *IssueDeleteStopWatchParams {
	return &IssueDeleteStopWatchParams{
		timeout: timeout,
	}
}

// NewIssueDeleteStopWatchParamsWithContext creates a new IssueDeleteStopWatchParams object
// with the ability to set a context for a request.
func NewIssueDeleteStopWatchParamsWithContext(ctx context.Context) *IssueDeleteStopWatchParams {
	return &IssueDeleteStopWatchParams{
		Context: ctx,
	}
}

// NewIssueDeleteStopWatchParamsWithHTTPClient creates a new IssueDeleteStopWatchParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueDeleteStopWatchParamsWithHTTPClient(client *http.Client) *IssueDeleteStopWatchParams {
	return &IssueDeleteStopWatchParams{
		HTTPClient: client,
	}
}

/*
IssueDeleteStopWatchParams contains all the parameters to send to the API endpoint

	for the issue delete stop watch operation.

	Typically these are written to a http.Request.
*/
type IssueDeleteStopWatchParams struct {

	/* Index.

	   index of the issue to stop the stopwatch on

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue delete stop watch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteStopWatchParams) WithDefaults() *IssueDeleteStopWatchParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue delete stop watch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteStopWatchParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) WithTimeout(timeout time.Duration) *IssueDeleteStopWatchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) WithContext(ctx context.Context) *IssueDeleteStopWatchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) WithHTTPClient(client *http.Client) *IssueDeleteStopWatchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) WithIndex(index int64) *IssueDeleteStopWatchParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) WithOwner(owner string) *IssueDeleteStopWatchParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) WithRepo(repo string) *IssueDeleteStopWatchParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue delete stop watch params
func (o *IssueDeleteStopWatchParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueDeleteStopWatchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
