// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewIssueEditLabelParams creates a new IssueEditLabelParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueEditLabelParams() *IssueEditLabelParams {
	return &IssueEditLabelParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueEditLabelParamsWithTimeout creates a new IssueEditLabelParams object
// with the ability to set a timeout on a request.
func NewIssueEditLabelParamsWithTimeout(timeout time.Duration) *IssueEditLabelParams {
	return &IssueEditLabelParams{
		timeout: timeout,
	}
}

// NewIssueEditLabelParamsWithContext creates a new IssueEditLabelParams object
// with the ability to set a context for a request.
func NewIssueEditLabelParamsWithContext(ctx context.Context) *IssueEditLabelParams {
	return &IssueEditLabelParams{
		Context: ctx,
	}
}

// NewIssueEditLabelParamsWithHTTPClient creates a new IssueEditLabelParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueEditLabelParamsWithHTTPClient(client *http.Client) *IssueEditLabelParams {
	return &IssueEditLabelParams{
		HTTPClient: client,
	}
}

/*
IssueEditLabelParams contains all the parameters to send to the API endpoint

	for the issue edit label operation.

	Typically these are written to a http.Request.
*/
type IssueEditLabelParams struct {

	// Body.
	Body *models.EditLabelOption

	/* ID.

	   id of the label to edit

	   Format: int64
	*/
	ID int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue edit label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueEditLabelParams) WithDefaults() *IssueEditLabelParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue edit label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueEditLabelParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue edit label params
func (o *IssueEditLabelParams) WithTimeout(timeout time.Duration) *IssueEditLabelParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue edit label params
func (o *IssueEditLabelParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue edit label params
func (o *IssueEditLabelParams) WithContext(ctx context.Context) *IssueEditLabelParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue edit label params
func (o *IssueEditLabelParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue edit label params
func (o *IssueEditLabelParams) WithHTTPClient(client *http.Client) *IssueEditLabelParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue edit label params
func (o *IssueEditLabelParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the issue edit label params
func (o *IssueEditLabelParams) WithBody(body *models.EditLabelOption) *IssueEditLabelParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the issue edit label params
func (o *IssueEditLabelParams) SetBody(body *models.EditLabelOption) {
	o.Body = body
}

// WithID adds the id to the issue edit label params
func (o *IssueEditLabelParams) WithID(id int64) *IssueEditLabelParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the issue edit label params
func (o *IssueEditLabelParams) SetID(id int64) {
	o.ID = id
}

// WithOwner adds the owner to the issue edit label params
func (o *IssueEditLabelParams) WithOwner(owner string) *IssueEditLabelParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue edit label params
func (o *IssueEditLabelParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue edit label params
func (o *IssueEditLabelParams) WithRepo(repo string) *IssueEditLabelParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue edit label params
func (o *IssueEditLabelParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueEditLabelParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
