// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewIssueEditMilestoneParams creates a new IssueEditMilestoneParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueEditMilestoneParams() *IssueEditMilestoneParams {
	return &IssueEditMilestoneParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueEditMilestoneParamsWithTimeout creates a new IssueEditMilestoneParams object
// with the ability to set a timeout on a request.
func NewIssueEditMilestoneParamsWithTimeout(timeout time.Duration) *IssueEditMilestoneParams {
	return &IssueEditMilestoneParams{
		timeout: timeout,
	}
}

// NewIssueEditMilestoneParamsWithContext creates a new IssueEditMilestoneParams object
// with the ability to set a context for a request.
func NewIssueEditMilestoneParamsWithContext(ctx context.Context) *IssueEditMilestoneParams {
	return &IssueEditMilestoneParams{
		Context: ctx,
	}
}

// NewIssueEditMilestoneParamsWithHTTPClient creates a new IssueEditMilestoneParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueEditMilestoneParamsWithHTTPClient(client *http.Client) *IssueEditMilestoneParams {
	return &IssueEditMilestoneParams{
		HTTPClient: client,
	}
}

/*
IssueEditMilestoneParams contains all the parameters to send to the API endpoint

	for the issue edit milestone operation.

	Typically these are written to a http.Request.
*/
type IssueEditMilestoneParams struct {

	// Body.
	Body *models.EditMilestoneOption

	/* ID.

	   the milestone to edit, identified by ID and if not available by name
	*/
	ID string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue edit milestone params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueEditMilestoneParams) WithDefaults() *IssueEditMilestoneParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue edit milestone params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueEditMilestoneParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue edit milestone params
func (o *IssueEditMilestoneParams) WithTimeout(timeout time.Duration) *IssueEditMilestoneParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue edit milestone params
func (o *IssueEditMilestoneParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue edit milestone params
func (o *IssueEditMilestoneParams) WithContext(ctx context.Context) *IssueEditMilestoneParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue edit milestone params
func (o *IssueEditMilestoneParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue edit milestone params
func (o *IssueEditMilestoneParams) WithHTTPClient(client *http.Client) *IssueEditMilestoneParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue edit milestone params
func (o *IssueEditMilestoneParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the issue edit milestone params
func (o *IssueEditMilestoneParams) WithBody(body *models.EditMilestoneOption) *IssueEditMilestoneParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the issue edit milestone params
func (o *IssueEditMilestoneParams) SetBody(body *models.EditMilestoneOption) {
	o.Body = body
}

// WithID adds the id to the issue edit milestone params
func (o *IssueEditMilestoneParams) WithID(id string) *IssueEditMilestoneParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the issue edit milestone params
func (o *IssueEditMilestoneParams) SetID(id string) {
	o.ID = id
}

// WithOwner adds the owner to the issue edit milestone params
func (o *IssueEditMilestoneParams) WithOwner(owner string) *IssueEditMilestoneParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue edit milestone params
func (o *IssueEditMilestoneParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue edit milestone params
func (o *IssueEditMilestoneParams) WithRepo(repo string) *IssueEditMilestoneParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue edit milestone params
func (o *IssueEditMilestoneParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueEditMilestoneParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
