// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueGetCommentsAndTimelineParams creates a new IssueGetCommentsAndTimelineParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueGetCommentsAndTimelineParams() *IssueGetCommentsAndTimelineParams {
	return &IssueGetCommentsAndTimelineParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueGetCommentsAndTimelineParamsWithTimeout creates a new IssueGetCommentsAndTimelineParams object
// with the ability to set a timeout on a request.
func NewIssueGetCommentsAndTimelineParamsWithTimeout(timeout time.Duration) *IssueGetCommentsAndTimelineParams {
	return &IssueGetCommentsAndTimelineParams{
		timeout: timeout,
	}
}

// NewIssueGetCommentsAndTimelineParamsWithContext creates a new IssueGetCommentsAndTimelineParams object
// with the ability to set a context for a request.
func NewIssueGetCommentsAndTimelineParamsWithContext(ctx context.Context) *IssueGetCommentsAndTimelineParams {
	return &IssueGetCommentsAndTimelineParams{
		Context: ctx,
	}
}

// NewIssueGetCommentsAndTimelineParamsWithHTTPClient creates a new IssueGetCommentsAndTimelineParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueGetCommentsAndTimelineParamsWithHTTPClient(client *http.Client) *IssueGetCommentsAndTimelineParams {
	return &IssueGetCommentsAndTimelineParams{
		HTTPClient: client,
	}
}

/*
IssueGetCommentsAndTimelineParams contains all the parameters to send to the API endpoint

	for the issue get comments and timeline operation.

	Typically these are written to a http.Request.
*/
type IssueGetCommentsAndTimelineParams struct {

	/* Before.

	   if provided, only comments updated before the provided time are returned.

	   Format: date-time
	*/
	Before *strfmt.DateTime

	/* Index.

	   index of the issue

	   Format: int64
	*/
	Index int64

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	/* Repo.

	   name of the repo
	*/
	Repo string

	/* Since.

	   if provided, only comments updated since the specified time are returned.

	   Format: date-time
	*/
	Since *strfmt.DateTime

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue get comments and timeline params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetCommentsAndTimelineParams) WithDefaults() *IssueGetCommentsAndTimelineParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue get comments and timeline params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetCommentsAndTimelineParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) WithTimeout(timeout time.Duration) *IssueGetCommentsAndTimelineParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) WithContext(ctx context.Context) *IssueGetCommentsAndTimelineParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) WithHTTPClient(client *http.Client) *IssueGetCommentsAndTimelineParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBefore adds the before to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) WithBefore(before *strfmt.DateTime) *IssueGetCommentsAndTimelineParams {
	o.SetBefore(before)
	return o
}

// SetBefore adds the before to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) SetBefore(before *strfmt.DateTime) {
	o.Before = before
}

// WithIndex adds the index to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) WithIndex(index int64) *IssueGetCommentsAndTimelineParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) SetIndex(index int64) {
	o.Index = index
}

// WithLimit adds the limit to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) WithLimit(limit *int64) *IssueGetCommentsAndTimelineParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOwner adds the owner to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) WithOwner(owner string) *IssueGetCommentsAndTimelineParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithPage adds the page to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) WithPage(page *int64) *IssueGetCommentsAndTimelineParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) SetPage(page *int64) {
	o.Page = page
}

// WithRepo adds the repo to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) WithRepo(repo string) *IssueGetCommentsAndTimelineParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithSince adds the since to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) WithSince(since *strfmt.DateTime) *IssueGetCommentsAndTimelineParams {
	o.SetSince(since)
	return o
}

// SetSince adds the since to the issue get comments and timeline params
func (o *IssueGetCommentsAndTimelineParams) SetSince(since *strfmt.DateTime) {
	o.Since = since
}

// WriteToRequest writes these params to a swagger request
func (o *IssueGetCommentsAndTimelineParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Before != nil {

		// query param before
		var qrBefore strfmt.DateTime

		if o.Before != nil {
			qrBefore = *o.Before
		}
		qBefore := qrBefore.String()
		if qBefore != "" {

			if err := r.SetQueryParam("before", qBefore); err != nil {
				return err
			}
		}
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if o.Since != nil {

		// query param since
		var qrSince strfmt.DateTime

		if o.Since != nil {
			qrSince = *o.Since
		}
		qSince := qrSince.String()
		if qSince != "" {

			if err := r.SetQueryParam("since", qSince); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
