// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueGetIssueReactionsParams creates a new IssueGetIssueReactionsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueGetIssueReactionsParams() *IssueGetIssueReactionsParams {
	return &IssueGetIssueReactionsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueGetIssueReactionsParamsWithTimeout creates a new IssueGetIssueReactionsParams object
// with the ability to set a timeout on a request.
func NewIssueGetIssueReactionsParamsWithTimeout(timeout time.Duration) *IssueGetIssueReactionsParams {
	return &IssueGetIssueReactionsParams{
		timeout: timeout,
	}
}

// NewIssueGetIssueReactionsParamsWithContext creates a new IssueGetIssueReactionsParams object
// with the ability to set a context for a request.
func NewIssueGetIssueReactionsParamsWithContext(ctx context.Context) *IssueGetIssueReactionsParams {
	return &IssueGetIssueReactionsParams{
		Context: ctx,
	}
}

// NewIssueGetIssueReactionsParamsWithHTTPClient creates a new IssueGetIssueReactionsParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueGetIssueReactionsParamsWithHTTPClient(client *http.Client) *IssueGetIssueReactionsParams {
	return &IssueGetIssueReactionsParams{
		HTTPClient: client,
	}
}

/*
IssueGetIssueReactionsParams contains all the parameters to send to the API endpoint

	for the issue get issue reactions operation.

	Typically these are written to a http.Request.
*/
type IssueGetIssueReactionsParams struct {

	/* Index.

	   index of the issue

	   Format: int64
	*/
	Index int64

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue get issue reactions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetIssueReactionsParams) WithDefaults() *IssueGetIssueReactionsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue get issue reactions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetIssueReactionsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) WithTimeout(timeout time.Duration) *IssueGetIssueReactionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) WithContext(ctx context.Context) *IssueGetIssueReactionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) WithHTTPClient(client *http.Client) *IssueGetIssueReactionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) WithIndex(index int64) *IssueGetIssueReactionsParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) SetIndex(index int64) {
	o.Index = index
}

// WithLimit adds the limit to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) WithLimit(limit *int64) *IssueGetIssueReactionsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOwner adds the owner to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) WithOwner(owner string) *IssueGetIssueReactionsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithPage adds the page to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) WithPage(page *int64) *IssueGetIssueReactionsParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) SetPage(page *int64) {
	o.Page = page
}

// WithRepo adds the repo to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) WithRepo(repo string) *IssueGetIssueReactionsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue get issue reactions params
func (o *IssueGetIssueReactionsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueGetIssueReactionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
