// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewMoveIssuePinParams creates a new MoveIssuePinParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMoveIssuePinParams() *MoveIssuePinParams {
	return &MoveIssuePinParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMoveIssuePinParamsWithTimeout creates a new MoveIssuePinParams object
// with the ability to set a timeout on a request.
func NewMoveIssuePinParamsWithTimeout(timeout time.Duration) *MoveIssuePinParams {
	return &MoveIssuePinParams{
		timeout: timeout,
	}
}

// NewMoveIssuePinParamsWithContext creates a new MoveIssuePinParams object
// with the ability to set a context for a request.
func NewMoveIssuePinParamsWithContext(ctx context.Context) *MoveIssuePinParams {
	return &MoveIssuePinParams{
		Context: ctx,
	}
}

// NewMoveIssuePinParamsWithHTTPClient creates a new MoveIssuePinParams object
// with the ability to set a custom HTTPClient for a request.
func NewMoveIssuePinParamsWithHTTPClient(client *http.Client) *MoveIssuePinParams {
	return &MoveIssuePinParams{
		HTTPClient: client,
	}
}

/*
MoveIssuePinParams contains all the parameters to send to the API endpoint

	for the move issue pin operation.

	Typically these are written to a http.Request.
*/
type MoveIssuePinParams struct {

	/* Index.

	   index of issue

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Position.

	   the new position

	   Format: int64
	*/
	Position int64

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the move issue pin params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MoveIssuePinParams) WithDefaults() *MoveIssuePinParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the move issue pin params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MoveIssuePinParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the move issue pin params
func (o *MoveIssuePinParams) WithTimeout(timeout time.Duration) *MoveIssuePinParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the move issue pin params
func (o *MoveIssuePinParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the move issue pin params
func (o *MoveIssuePinParams) WithContext(ctx context.Context) *MoveIssuePinParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the move issue pin params
func (o *MoveIssuePinParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the move issue pin params
func (o *MoveIssuePinParams) WithHTTPClient(client *http.Client) *MoveIssuePinParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the move issue pin params
func (o *MoveIssuePinParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the move issue pin params
func (o *MoveIssuePinParams) WithIndex(index int64) *MoveIssuePinParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the move issue pin params
func (o *MoveIssuePinParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the move issue pin params
func (o *MoveIssuePinParams) WithOwner(owner string) *MoveIssuePinParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the move issue pin params
func (o *MoveIssuePinParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithPosition adds the position to the move issue pin params
func (o *MoveIssuePinParams) WithPosition(position int64) *MoveIssuePinParams {
	o.SetPosition(position)
	return o
}

// SetPosition adds the position to the move issue pin params
func (o *MoveIssuePinParams) SetPosition(position int64) {
	o.Position = position
}

// WithRepo adds the repo to the move issue pin params
func (o *MoveIssuePinParams) WithRepo(repo string) *MoveIssuePinParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the move issue pin params
func (o *MoveIssuePinParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *MoveIssuePinParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param position
	if err := r.SetPathParam("position", swag.FormatInt64(o.Position)); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
