// Code generated by go-swagger; DO NOT EDIT.

package notification

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	httptransport "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// New creates a new notification API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

// New creates a new notification API client with basic auth credentials.
// It takes the following parameters:
// - host: http host (github.com).
// - basePath: any base path for the API client ("/v1", "/v3").
// - scheme: http scheme ("http", "https").
// - user: user for basic authentication header.
// - password: password for basic authentication header.
func NewClientWithBasicAuth(host, basePath, scheme, user, password string) ClientService {
	transport := httptransport.New(host, basePath, []string{scheme})
	transport.DefaultAuthentication = httptransport.BasicAuth(user, password)
	return &Client{transport: transport, formats: strfmt.Default}
}

// New creates a new notification API client with a bearer token for authentication.
// It takes the following parameters:
// - host: http host (github.com).
// - basePath: any base path for the API client ("/v1", "/v3").
// - scheme: http scheme ("http", "https").
// - bearerToken: bearer token for Bearer authentication header.
func NewClientWithBearerToken(host, basePath, scheme, bearerToken string) ClientService {
	transport := httptransport.New(host, basePath, []string{scheme})
	transport.DefaultAuthentication = httptransport.BearerToken(bearerToken)
	return &Client{transport: transport, formats: strfmt.Default}
}

/*
Client for notification API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption may be used to customize the behavior of Client methods.
type ClientOption func(*runtime.ClientOperation)

// This client is generated with a few options you might find useful for your swagger spec.
//
// Feel free to add you own set of options.

// WithContentType allows the client to force the Content-Type header
// to negotiate a specific Consumer from the server.
//
// You may use this option to set arbitrary extensions to your MIME media type.
func WithContentType(mime string) ClientOption {
	return func(r *runtime.ClientOperation) {
		r.ConsumesMediaTypes = []string{mime}
	}
}

// WithContentTypeApplicationJSON sets the Content-Type header to "application/json".
func WithContentTypeApplicationJSON(r *runtime.ClientOperation) {
	r.ConsumesMediaTypes = []string{"application/json"}
}

// WithContentTypeTextPlain sets the Content-Type header to "text/plain".
func WithContentTypeTextPlain(r *runtime.ClientOperation) {
	r.ConsumesMediaTypes = []string{"text/plain"}
}

// WithAccept allows the client to force the Accept header
// to negotiate a specific Producer from the server.
//
// You may use this option to set arbitrary extensions to your MIME media type.
func WithAccept(mime string) ClientOption {
	return func(r *runtime.ClientOperation) {
		r.ProducesMediaTypes = []string{mime}
	}
}

// WithAcceptApplicationJSON sets the Accept header to "application/json".
func WithAcceptApplicationJSON(r *runtime.ClientOperation) {
	r.ProducesMediaTypes = []string{"application/json"}
}

// WithAcceptTextHTML sets the Accept header to "text/html".
func WithAcceptTextHTML(r *runtime.ClientOperation) {
	r.ProducesMediaTypes = []string{"text/html"}
}

// ClientService is the interface for Client methods
type ClientService interface {
	NotifyGetList(params *NotifyGetListParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyGetListOK, error)

	NotifyGetRepoList(params *NotifyGetRepoListParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyGetRepoListOK, error)

	NotifyGetThread(params *NotifyGetThreadParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyGetThreadOK, error)

	NotifyNewAvailable(params *NotifyNewAvailableParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyNewAvailableOK, error)

	NotifyReadList(params *NotifyReadListParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyReadListResetContent, error)

	NotifyReadRepoList(params *NotifyReadRepoListParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyReadRepoListResetContent, error)

	NotifyReadThread(params *NotifyReadThreadParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyReadThreadResetContent, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
NotifyGetList lists users s notification threads
*/
func (a *Client) NotifyGetList(params *NotifyGetListParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyGetListOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewNotifyGetListParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "notifyGetList",
		Method:             "GET",
		PathPattern:        "/notifications",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &NotifyGetListReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*NotifyGetListOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for notifyGetList: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
NotifyGetRepoList lists users s notification threads on a specific repo
*/
func (a *Client) NotifyGetRepoList(params *NotifyGetRepoListParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyGetRepoListOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewNotifyGetRepoListParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "notifyGetRepoList",
		Method:             "GET",
		PathPattern:        "/repos/{owner}/{repo}/notifications",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &NotifyGetRepoListReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*NotifyGetRepoListOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for notifyGetRepoList: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
NotifyGetThread gets notification thread by ID
*/
func (a *Client) NotifyGetThread(params *NotifyGetThreadParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyGetThreadOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewNotifyGetThreadParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "notifyGetThread",
		Method:             "GET",
		PathPattern:        "/notifications/threads/{id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &NotifyGetThreadReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*NotifyGetThreadOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for notifyGetThread: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
NotifyNewAvailable checks if unread notifications exist
*/
func (a *Client) NotifyNewAvailable(params *NotifyNewAvailableParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyNewAvailableOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewNotifyNewAvailableParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "notifyNewAvailable",
		Method:             "GET",
		PathPattern:        "/notifications/new",
		ProducesMediaTypes: []string{"application/json", "text/html"},
		ConsumesMediaTypes: []string{"application/json", "text/plain"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &NotifyNewAvailableReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*NotifyNewAvailableOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for notifyNewAvailable: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
NotifyReadList marks notification threads as read pinned or unread
*/
func (a *Client) NotifyReadList(params *NotifyReadListParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyReadListResetContent, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewNotifyReadListParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "notifyReadList",
		Method:             "PUT",
		PathPattern:        "/notifications",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &NotifyReadListReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*NotifyReadListResetContent)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for notifyReadList: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
NotifyReadRepoList marks notification threads as read pinned or unread on a specific repo
*/
func (a *Client) NotifyReadRepoList(params *NotifyReadRepoListParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyReadRepoListResetContent, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewNotifyReadRepoListParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "notifyReadRepoList",
		Method:             "PUT",
		PathPattern:        "/repos/{owner}/{repo}/notifications",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &NotifyReadRepoListReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*NotifyReadRepoListResetContent)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for notifyReadRepoList: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
NotifyReadThread marks notification thread as read by ID
*/
func (a *Client) NotifyReadThread(params *NotifyReadThreadParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*NotifyReadThreadResetContent, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewNotifyReadThreadParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "notifyReadThread",
		Method:             "PATCH",
		PathPattern:        "/notifications/threads/{id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &NotifyReadThreadReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*NotifyReadThreadResetContent)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for notifyReadThread: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
