// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// GetOrgVariableReader is a Reader for the GetOrgVariable structure.
type GetOrgVariableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetOrgVariableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetOrgVariableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewGetOrgVariableBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetOrgVariableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /orgs/{org}/actions/variables/{variablename}] getOrgVariable", response, response.Code())
	}
}

// NewGetOrgVariableOK creates a GetOrgVariableOK with default headers values
func NewGetOrgVariableOK() *GetOrgVariableOK {
	return &GetOrgVariableOK{}
}

/*
GetOrgVariableOK describes a response with status code 200, with default header values.

ActionVariable
*/
type GetOrgVariableOK struct {
	Payload *models.ActionVariable
}

// IsSuccess returns true when this get org variable o k response has a 2xx status code
func (o *GetOrgVariableOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get org variable o k response has a 3xx status code
func (o *GetOrgVariableOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get org variable o k response has a 4xx status code
func (o *GetOrgVariableOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get org variable o k response has a 5xx status code
func (o *GetOrgVariableOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get org variable o k response a status code equal to that given
func (o *GetOrgVariableOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get org variable o k response
func (o *GetOrgVariableOK) Code() int {
	return 200
}

func (o *GetOrgVariableOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables/{variablename}][%d] getOrgVariableOK %s", 200, payload)
}

func (o *GetOrgVariableOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables/{variablename}][%d] getOrgVariableOK %s", 200, payload)
}

func (o *GetOrgVariableOK) GetPayload() *models.ActionVariable {
	return o.Payload
}

func (o *GetOrgVariableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ActionVariable)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetOrgVariableBadRequest creates a GetOrgVariableBadRequest with default headers values
func NewGetOrgVariableBadRequest() *GetOrgVariableBadRequest {
	return &GetOrgVariableBadRequest{}
}

/*
GetOrgVariableBadRequest describes a response with status code 400, with default header values.

APIError is error format response
*/
type GetOrgVariableBadRequest struct {
	Message string
	URL     string
}

// IsSuccess returns true when this get org variable bad request response has a 2xx status code
func (o *GetOrgVariableBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get org variable bad request response has a 3xx status code
func (o *GetOrgVariableBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get org variable bad request response has a 4xx status code
func (o *GetOrgVariableBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this get org variable bad request response has a 5xx status code
func (o *GetOrgVariableBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this get org variable bad request response a status code equal to that given
func (o *GetOrgVariableBadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the get org variable bad request response
func (o *GetOrgVariableBadRequest) Code() int {
	return 400
}

func (o *GetOrgVariableBadRequest) Error() string {
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables/{variablename}][%d] getOrgVariableBadRequest", 400)
}

func (o *GetOrgVariableBadRequest) String() string {
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables/{variablename}][%d] getOrgVariableBadRequest", 400)
}

func (o *GetOrgVariableBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header message
	hdrMessage := response.GetHeader("message")

	if hdrMessage != "" {
		o.Message = hdrMessage
	}

	// hydrates response header url
	hdrURL := response.GetHeader("url")

	if hdrURL != "" {
		o.URL = hdrURL
	}

	return nil
}

// NewGetOrgVariableNotFound creates a GetOrgVariableNotFound with default headers values
func NewGetOrgVariableNotFound() *GetOrgVariableNotFound {
	return &GetOrgVariableNotFound{}
}

/*
GetOrgVariableNotFound describes a response with status code 404, with default header values.

APINotFound is a not found empty response
*/
type GetOrgVariableNotFound struct {
}

// IsSuccess returns true when this get org variable not found response has a 2xx status code
func (o *GetOrgVariableNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get org variable not found response has a 3xx status code
func (o *GetOrgVariableNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get org variable not found response has a 4xx status code
func (o *GetOrgVariableNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get org variable not found response has a 5xx status code
func (o *GetOrgVariableNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get org variable not found response a status code equal to that given
func (o *GetOrgVariableNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get org variable not found response
func (o *GetOrgVariableNotFound) Code() int {
	return 404
}

func (o *GetOrgVariableNotFound) Error() string {
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables/{variablename}][%d] getOrgVariableNotFound", 404)
}

func (o *GetOrgVariableNotFound) String() string {
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables/{variablename}][%d] getOrgVariableNotFound", 404)
}

func (o *GetOrgVariableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
