// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewOrgCreateLabelParams creates a new OrgCreateLabelParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgCreateLabelParams() *OrgCreateLabelParams {
	return &OrgCreateLabelParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgCreateLabelParamsWithTimeout creates a new OrgCreateLabelParams object
// with the ability to set a timeout on a request.
func NewOrgCreateLabelParamsWithTimeout(timeout time.Duration) *OrgCreateLabelParams {
	return &OrgCreateLabelParams{
		timeout: timeout,
	}
}

// NewOrgCreateLabelParamsWithContext creates a new OrgCreateLabelParams object
// with the ability to set a context for a request.
func NewOrgCreateLabelParamsWithContext(ctx context.Context) *OrgCreateLabelParams {
	return &OrgCreateLabelParams{
		Context: ctx,
	}
}

// NewOrgCreateLabelParamsWithHTTPClient creates a new OrgCreateLabelParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgCreateLabelParamsWithHTTPClient(client *http.Client) *OrgCreateLabelParams {
	return &OrgCreateLabelParams{
		HTTPClient: client,
	}
}

/*
OrgCreateLabelParams contains all the parameters to send to the API endpoint

	for the org create label operation.

	Typically these are written to a http.Request.
*/
type OrgCreateLabelParams struct {

	// Body.
	Body *models.CreateLabelOption

	/* Org.

	   name of the organization
	*/
	Org string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org create label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgCreateLabelParams) WithDefaults() *OrgCreateLabelParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org create label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgCreateLabelParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org create label params
func (o *OrgCreateLabelParams) WithTimeout(timeout time.Duration) *OrgCreateLabelParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org create label params
func (o *OrgCreateLabelParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org create label params
func (o *OrgCreateLabelParams) WithContext(ctx context.Context) *OrgCreateLabelParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org create label params
func (o *OrgCreateLabelParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org create label params
func (o *OrgCreateLabelParams) WithHTTPClient(client *http.Client) *OrgCreateLabelParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org create label params
func (o *OrgCreateLabelParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the org create label params
func (o *OrgCreateLabelParams) WithBody(body *models.CreateLabelOption) *OrgCreateLabelParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the org create label params
func (o *OrgCreateLabelParams) SetBody(body *models.CreateLabelOption) {
	o.Body = body
}

// WithOrg adds the org to the org create label params
func (o *OrgCreateLabelParams) WithOrg(org string) *OrgCreateLabelParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the org create label params
func (o *OrgCreateLabelParams) SetOrg(org string) {
	o.Org = org
}

// WriteToRequest writes these params to a swagger request
func (o *OrgCreateLabelParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
