// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewOrgCreateTeamParams creates a new OrgCreateTeamParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgCreateTeamParams() *OrgCreateTeamParams {
	return &OrgCreateTeamParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgCreateTeamParamsWithTimeout creates a new OrgCreateTeamParams object
// with the ability to set a timeout on a request.
func NewOrgCreateTeamParamsWithTimeout(timeout time.Duration) *OrgCreateTeamParams {
	return &OrgCreateTeamParams{
		timeout: timeout,
	}
}

// NewOrgCreateTeamParamsWithContext creates a new OrgCreateTeamParams object
// with the ability to set a context for a request.
func NewOrgCreateTeamParamsWithContext(ctx context.Context) *OrgCreateTeamParams {
	return &OrgCreateTeamParams{
		Context: ctx,
	}
}

// NewOrgCreateTeamParamsWithHTTPClient creates a new OrgCreateTeamParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgCreateTeamParamsWithHTTPClient(client *http.Client) *OrgCreateTeamParams {
	return &OrgCreateTeamParams{
		HTTPClient: client,
	}
}

/*
OrgCreateTeamParams contains all the parameters to send to the API endpoint

	for the org create team operation.

	Typically these are written to a http.Request.
*/
type OrgCreateTeamParams struct {

	// Body.
	Body *models.CreateTeamOption

	/* Org.

	   name of the organization
	*/
	Org string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org create team params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgCreateTeamParams) WithDefaults() *OrgCreateTeamParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org create team params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgCreateTeamParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org create team params
func (o *OrgCreateTeamParams) WithTimeout(timeout time.Duration) *OrgCreateTeamParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org create team params
func (o *OrgCreateTeamParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org create team params
func (o *OrgCreateTeamParams) WithContext(ctx context.Context) *OrgCreateTeamParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org create team params
func (o *OrgCreateTeamParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org create team params
func (o *OrgCreateTeamParams) WithHTTPClient(client *http.Client) *OrgCreateTeamParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org create team params
func (o *OrgCreateTeamParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the org create team params
func (o *OrgCreateTeamParams) WithBody(body *models.CreateTeamOption) *OrgCreateTeamParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the org create team params
func (o *OrgCreateTeamParams) SetBody(body *models.CreateTeamOption) {
	o.Body = body
}

// WithOrg adds the org to the org create team params
func (o *OrgCreateTeamParams) WithOrg(org string) *OrgCreateTeamParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the org create team params
func (o *OrgCreateTeamParams) SetOrg(org string) {
	o.Org = org
}

// WriteToRequest writes these params to a swagger request
func (o *OrgCreateTeamParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
