// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewOrgDeleteLabelParams creates a new OrgDeleteLabelParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgDeleteLabelParams() *OrgDeleteLabelParams {
	return &OrgDeleteLabelParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgDeleteLabelParamsWithTimeout creates a new OrgDeleteLabelParams object
// with the ability to set a timeout on a request.
func NewOrgDeleteLabelParamsWithTimeout(timeout time.Duration) *OrgDeleteLabelParams {
	return &OrgDeleteLabelParams{
		timeout: timeout,
	}
}

// NewOrgDeleteLabelParamsWithContext creates a new OrgDeleteLabelParams object
// with the ability to set a context for a request.
func NewOrgDeleteLabelParamsWithContext(ctx context.Context) *OrgDeleteLabelParams {
	return &OrgDeleteLabelParams{
		Context: ctx,
	}
}

// NewOrgDeleteLabelParamsWithHTTPClient creates a new OrgDeleteLabelParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgDeleteLabelParamsWithHTTPClient(client *http.Client) *OrgDeleteLabelParams {
	return &OrgDeleteLabelParams{
		HTTPClient: client,
	}
}

/*
OrgDeleteLabelParams contains all the parameters to send to the API endpoint

	for the org delete label operation.

	Typically these are written to a http.Request.
*/
type OrgDeleteLabelParams struct {

	/* ID.

	   id of the label to delete

	   Format: int64
	*/
	ID int64

	/* Org.

	   name of the organization
	*/
	Org string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org delete label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgDeleteLabelParams) WithDefaults() *OrgDeleteLabelParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org delete label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgDeleteLabelParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org delete label params
func (o *OrgDeleteLabelParams) WithTimeout(timeout time.Duration) *OrgDeleteLabelParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org delete label params
func (o *OrgDeleteLabelParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org delete label params
func (o *OrgDeleteLabelParams) WithContext(ctx context.Context) *OrgDeleteLabelParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org delete label params
func (o *OrgDeleteLabelParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org delete label params
func (o *OrgDeleteLabelParams) WithHTTPClient(client *http.Client) *OrgDeleteLabelParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org delete label params
func (o *OrgDeleteLabelParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the org delete label params
func (o *OrgDeleteLabelParams) WithID(id int64) *OrgDeleteLabelParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the org delete label params
func (o *OrgDeleteLabelParams) SetID(id int64) {
	o.ID = id
}

// WithOrg adds the org to the org delete label params
func (o *OrgDeleteLabelParams) WithOrg(org string) *OrgDeleteLabelParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the org delete label params
func (o *OrgDeleteLabelParams) SetOrg(org string) {
	o.Org = org
}

// WriteToRequest writes these params to a swagger request
func (o *OrgDeleteLabelParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
