// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewOrgEditLabelParams creates a new OrgEditLabelParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgEditLabelParams() *OrgEditLabelParams {
	return &OrgEditLabelParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgEditLabelParamsWithTimeout creates a new OrgEditLabelParams object
// with the ability to set a timeout on a request.
func NewOrgEditLabelParamsWithTimeout(timeout time.Duration) *OrgEditLabelParams {
	return &OrgEditLabelParams{
		timeout: timeout,
	}
}

// NewOrgEditLabelParamsWithContext creates a new OrgEditLabelParams object
// with the ability to set a context for a request.
func NewOrgEditLabelParamsWithContext(ctx context.Context) *OrgEditLabelParams {
	return &OrgEditLabelParams{
		Context: ctx,
	}
}

// NewOrgEditLabelParamsWithHTTPClient creates a new OrgEditLabelParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgEditLabelParamsWithHTTPClient(client *http.Client) *OrgEditLabelParams {
	return &OrgEditLabelParams{
		HTTPClient: client,
	}
}

/*
OrgEditLabelParams contains all the parameters to send to the API endpoint

	for the org edit label operation.

	Typically these are written to a http.Request.
*/
type OrgEditLabelParams struct {

	// Body.
	Body *models.EditLabelOption

	/* ID.

	   id of the label to edit

	   Format: int64
	*/
	ID int64

	/* Org.

	   name of the organization
	*/
	Org string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org edit label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgEditLabelParams) WithDefaults() *OrgEditLabelParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org edit label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgEditLabelParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org edit label params
func (o *OrgEditLabelParams) WithTimeout(timeout time.Duration) *OrgEditLabelParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org edit label params
func (o *OrgEditLabelParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org edit label params
func (o *OrgEditLabelParams) WithContext(ctx context.Context) *OrgEditLabelParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org edit label params
func (o *OrgEditLabelParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org edit label params
func (o *OrgEditLabelParams) WithHTTPClient(client *http.Client) *OrgEditLabelParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org edit label params
func (o *OrgEditLabelParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the org edit label params
func (o *OrgEditLabelParams) WithBody(body *models.EditLabelOption) *OrgEditLabelParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the org edit label params
func (o *OrgEditLabelParams) SetBody(body *models.EditLabelOption) {
	o.Body = body
}

// WithID adds the id to the org edit label params
func (o *OrgEditLabelParams) WithID(id int64) *OrgEditLabelParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the org edit label params
func (o *OrgEditLabelParams) SetID(id int64) {
	o.ID = id
}

// WithOrg adds the org to the org edit label params
func (o *OrgEditLabelParams) WithOrg(org string) *OrgEditLabelParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the org edit label params
func (o *OrgEditLabelParams) SetOrg(org string) {
	o.Org = org
}

// WriteToRequest writes these params to a swagger request
func (o *OrgEditLabelParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
