// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewOrgUpdateAvatarParams creates a new OrgUpdateAvatarParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgUpdateAvatarParams() *OrgUpdateAvatarParams {
	return &OrgUpdateAvatarParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgUpdateAvatarParamsWithTimeout creates a new OrgUpdateAvatarParams object
// with the ability to set a timeout on a request.
func NewOrgUpdateAvatarParamsWithTimeout(timeout time.Duration) *OrgUpdateAvatarParams {
	return &OrgUpdateAvatarParams{
		timeout: timeout,
	}
}

// NewOrgUpdateAvatarParamsWithContext creates a new OrgUpdateAvatarParams object
// with the ability to set a context for a request.
func NewOrgUpdateAvatarParamsWithContext(ctx context.Context) *OrgUpdateAvatarParams {
	return &OrgUpdateAvatarParams{
		Context: ctx,
	}
}

// NewOrgUpdateAvatarParamsWithHTTPClient creates a new OrgUpdateAvatarParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgUpdateAvatarParamsWithHTTPClient(client *http.Client) *OrgUpdateAvatarParams {
	return &OrgUpdateAvatarParams{
		HTTPClient: client,
	}
}

/*
OrgUpdateAvatarParams contains all the parameters to send to the API endpoint

	for the org update avatar operation.

	Typically these are written to a http.Request.
*/
type OrgUpdateAvatarParams struct {

	// Body.
	Body *models.UpdateUserAvatarOption

	/* Org.

	   name of the organization
	*/
	Org string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org update avatar params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgUpdateAvatarParams) WithDefaults() *OrgUpdateAvatarParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org update avatar params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgUpdateAvatarParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org update avatar params
func (o *OrgUpdateAvatarParams) WithTimeout(timeout time.Duration) *OrgUpdateAvatarParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org update avatar params
func (o *OrgUpdateAvatarParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org update avatar params
func (o *OrgUpdateAvatarParams) WithContext(ctx context.Context) *OrgUpdateAvatarParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org update avatar params
func (o *OrgUpdateAvatarParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org update avatar params
func (o *OrgUpdateAvatarParams) WithHTTPClient(client *http.Client) *OrgUpdateAvatarParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org update avatar params
func (o *OrgUpdateAvatarParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the org update avatar params
func (o *OrgUpdateAvatarParams) WithBody(body *models.UpdateUserAvatarOption) *OrgUpdateAvatarParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the org update avatar params
func (o *OrgUpdateAvatarParams) SetBody(body *models.UpdateUserAvatarOption) {
	o.Body = body
}

// WithOrg adds the org to the org update avatar params
func (o *OrgUpdateAvatarParams) WithOrg(org string) *OrgUpdateAvatarParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the org update avatar params
func (o *OrgUpdateAvatarParams) SetOrg(org string) {
	o.Org = org
}

// WriteToRequest writes these params to a swagger request
func (o *OrgUpdateAvatarParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
