// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteRepoVariableParams creates a new DeleteRepoVariableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteRepoVariableParams() *DeleteRepoVariableParams {
	return &DeleteRepoVariableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteRepoVariableParamsWithTimeout creates a new DeleteRepoVariableParams object
// with the ability to set a timeout on a request.
func NewDeleteRepoVariableParamsWithTimeout(timeout time.Duration) *DeleteRepoVariableParams {
	return &DeleteRepoVariableParams{
		timeout: timeout,
	}
}

// NewDeleteRepoVariableParamsWithContext creates a new DeleteRepoVariableParams object
// with the ability to set a context for a request.
func NewDeleteRepoVariableParamsWithContext(ctx context.Context) *DeleteRepoVariableParams {
	return &DeleteRepoVariableParams{
		Context: ctx,
	}
}

// NewDeleteRepoVariableParamsWithHTTPClient creates a new DeleteRepoVariableParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteRepoVariableParamsWithHTTPClient(client *http.Client) *DeleteRepoVariableParams {
	return &DeleteRepoVariableParams{
		HTTPClient: client,
	}
}

/*
DeleteRepoVariableParams contains all the parameters to send to the API endpoint

	for the delete repo variable operation.

	Typically these are written to a http.Request.
*/
type DeleteRepoVariableParams struct {

	/* Owner.

	   name of the owner
	*/
	Owner string

	/* Repo.

	   name of the repository
	*/
	Repo string

	/* Variablename.

	   name of the variable
	*/
	Variablename string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete repo variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteRepoVariableParams) WithDefaults() *DeleteRepoVariableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete repo variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteRepoVariableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete repo variable params
func (o *DeleteRepoVariableParams) WithTimeout(timeout time.Duration) *DeleteRepoVariableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete repo variable params
func (o *DeleteRepoVariableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete repo variable params
func (o *DeleteRepoVariableParams) WithContext(ctx context.Context) *DeleteRepoVariableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete repo variable params
func (o *DeleteRepoVariableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete repo variable params
func (o *DeleteRepoVariableParams) WithHTTPClient(client *http.Client) *DeleteRepoVariableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete repo variable params
func (o *DeleteRepoVariableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the delete repo variable params
func (o *DeleteRepoVariableParams) WithOwner(owner string) *DeleteRepoVariableParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the delete repo variable params
func (o *DeleteRepoVariableParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the delete repo variable params
func (o *DeleteRepoVariableParams) WithRepo(repo string) *DeleteRepoVariableParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the delete repo variable params
func (o *DeleteRepoVariableParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithVariablename adds the variablename to the delete repo variable params
func (o *DeleteRepoVariableParams) WithVariablename(variablename string) *DeleteRepoVariableParams {
	o.SetVariablename(variablename)
	return o
}

// SetVariablename adds the variablename to the delete repo variable params
func (o *DeleteRepoVariableParams) SetVariablename(variablename string) {
	o.Variablename = variablename
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteRepoVariableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	// path param variablename
	if err := r.SetPathParam("variablename", o.Variablename); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
