// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetRepoVariablesListParams creates a new GetRepoVariablesListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetRepoVariablesListParams() *GetRepoVariablesListParams {
	return &GetRepoVariablesListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetRepoVariablesListParamsWithTimeout creates a new GetRepoVariablesListParams object
// with the ability to set a timeout on a request.
func NewGetRepoVariablesListParamsWithTimeout(timeout time.Duration) *GetRepoVariablesListParams {
	return &GetRepoVariablesListParams{
		timeout: timeout,
	}
}

// NewGetRepoVariablesListParamsWithContext creates a new GetRepoVariablesListParams object
// with the ability to set a context for a request.
func NewGetRepoVariablesListParamsWithContext(ctx context.Context) *GetRepoVariablesListParams {
	return &GetRepoVariablesListParams{
		Context: ctx,
	}
}

// NewGetRepoVariablesListParamsWithHTTPClient creates a new GetRepoVariablesListParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetRepoVariablesListParamsWithHTTPClient(client *http.Client) *GetRepoVariablesListParams {
	return &GetRepoVariablesListParams{
		HTTPClient: client,
	}
}

/*
GetRepoVariablesListParams contains all the parameters to send to the API endpoint

	for the get repo variables list operation.

	Typically these are written to a http.Request.
*/
type GetRepoVariablesListParams struct {

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Owner.

	   name of the owner
	*/
	Owner string

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	/* Repo.

	   name of the repository
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get repo variables list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetRepoVariablesListParams) WithDefaults() *GetRepoVariablesListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get repo variables list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetRepoVariablesListParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get repo variables list params
func (o *GetRepoVariablesListParams) WithTimeout(timeout time.Duration) *GetRepoVariablesListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get repo variables list params
func (o *GetRepoVariablesListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get repo variables list params
func (o *GetRepoVariablesListParams) WithContext(ctx context.Context) *GetRepoVariablesListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get repo variables list params
func (o *GetRepoVariablesListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get repo variables list params
func (o *GetRepoVariablesListParams) WithHTTPClient(client *http.Client) *GetRepoVariablesListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get repo variables list params
func (o *GetRepoVariablesListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get repo variables list params
func (o *GetRepoVariablesListParams) WithLimit(limit *int64) *GetRepoVariablesListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get repo variables list params
func (o *GetRepoVariablesListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOwner adds the owner to the get repo variables list params
func (o *GetRepoVariablesListParams) WithOwner(owner string) *GetRepoVariablesListParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the get repo variables list params
func (o *GetRepoVariablesListParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithPage adds the page to the get repo variables list params
func (o *GetRepoVariablesListParams) WithPage(page *int64) *GetRepoVariablesListParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the get repo variables list params
func (o *GetRepoVariablesListParams) SetPage(page *int64) {
	o.Page = page
}

// WithRepo adds the repo to the get repo variables list params
func (o *GetRepoVariablesListParams) WithRepo(repo string) *GetRepoVariablesListParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the get repo variables list params
func (o *GetRepoVariablesListParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *GetRepoVariablesListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
