// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewListForksParams creates a new ListForksParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListForksParams() *ListForksParams {
	return &ListForksParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListForksParamsWithTimeout creates a new ListForksParams object
// with the ability to set a timeout on a request.
func NewListForksParamsWithTimeout(timeout time.Duration) *ListForksParams {
	return &ListForksParams{
		timeout: timeout,
	}
}

// NewListForksParamsWithContext creates a new ListForksParams object
// with the ability to set a context for a request.
func NewListForksParamsWithContext(ctx context.Context) *ListForksParams {
	return &ListForksParams{
		Context: ctx,
	}
}

// NewListForksParamsWithHTTPClient creates a new ListForksParams object
// with the ability to set a custom HTTPClient for a request.
func NewListForksParamsWithHTTPClient(client *http.Client) *ListForksParams {
	return &ListForksParams{
		HTTPClient: client,
	}
}

/*
ListForksParams contains all the parameters to send to the API endpoint

	for the list forks operation.

	Typically these are written to a http.Request.
*/
type ListForksParams struct {

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list forks params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListForksParams) WithDefaults() *ListForksParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list forks params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListForksParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list forks params
func (o *ListForksParams) WithTimeout(timeout time.Duration) *ListForksParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list forks params
func (o *ListForksParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list forks params
func (o *ListForksParams) WithContext(ctx context.Context) *ListForksParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list forks params
func (o *ListForksParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list forks params
func (o *ListForksParams) WithHTTPClient(client *http.Client) *ListForksParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list forks params
func (o *ListForksParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the list forks params
func (o *ListForksParams) WithLimit(limit *int64) *ListForksParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the list forks params
func (o *ListForksParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOwner adds the owner to the list forks params
func (o *ListForksParams) WithOwner(owner string) *ListForksParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the list forks params
func (o *ListForksParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithPage adds the page to the list forks params
func (o *ListForksParams) WithPage(page *int64) *ListForksParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the list forks params
func (o *ListForksParams) SetPage(page *int64) {
	o.Page = page
}

// WithRepo adds the repo to the list forks params
func (o *ListForksParams) WithRepo(repo string) *ListForksParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the list forks params
func (o *ListForksParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *ListForksParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
