// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRejectRepoTransferParams creates a new RejectRepoTransferParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRejectRepoTransferParams() *RejectRepoTransferParams {
	return &RejectRepoTransferParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRejectRepoTransferParamsWithTimeout creates a new RejectRepoTransferParams object
// with the ability to set a timeout on a request.
func NewRejectRepoTransferParamsWithTimeout(timeout time.Duration) *RejectRepoTransferParams {
	return &RejectRepoTransferParams{
		timeout: timeout,
	}
}

// NewRejectRepoTransferParamsWithContext creates a new RejectRepoTransferParams object
// with the ability to set a context for a request.
func NewRejectRepoTransferParamsWithContext(ctx context.Context) *RejectRepoTransferParams {
	return &RejectRepoTransferParams{
		Context: ctx,
	}
}

// NewRejectRepoTransferParamsWithHTTPClient creates a new RejectRepoTransferParams object
// with the ability to set a custom HTTPClient for a request.
func NewRejectRepoTransferParamsWithHTTPClient(client *http.Client) *RejectRepoTransferParams {
	return &RejectRepoTransferParams{
		HTTPClient: client,
	}
}

/*
RejectRepoTransferParams contains all the parameters to send to the API endpoint

	for the reject repo transfer operation.

	Typically these are written to a http.Request.
*/
type RejectRepoTransferParams struct {

	/* Owner.

	   owner of the repo to transfer
	*/
	Owner string

	/* Repo.

	   name of the repo to transfer
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the reject repo transfer params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RejectRepoTransferParams) WithDefaults() *RejectRepoTransferParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the reject repo transfer params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RejectRepoTransferParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the reject repo transfer params
func (o *RejectRepoTransferParams) WithTimeout(timeout time.Duration) *RejectRepoTransferParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the reject repo transfer params
func (o *RejectRepoTransferParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the reject repo transfer params
func (o *RejectRepoTransferParams) WithContext(ctx context.Context) *RejectRepoTransferParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the reject repo transfer params
func (o *RejectRepoTransferParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the reject repo transfer params
func (o *RejectRepoTransferParams) WithHTTPClient(client *http.Client) *RejectRepoTransferParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the reject repo transfer params
func (o *RejectRepoTransferParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the reject repo transfer params
func (o *RejectRepoTransferParams) WithOwner(owner string) *RejectRepoTransferParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the reject repo transfer params
func (o *RejectRepoTransferParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the reject repo transfer params
func (o *RejectRepoTransferParams) WithRepo(repo string) *RejectRepoTransferParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the reject repo transfer params
func (o *RejectRepoTransferParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RejectRepoTransferParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
