// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoAddPushMirrorParams creates a new RepoAddPushMirrorParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoAddPushMirrorParams() *RepoAddPushMirrorParams {
	return &RepoAddPushMirrorParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoAddPushMirrorParamsWithTimeout creates a new RepoAddPushMirrorParams object
// with the ability to set a timeout on a request.
func NewRepoAddPushMirrorParamsWithTimeout(timeout time.Duration) *RepoAddPushMirrorParams {
	return &RepoAddPushMirrorParams{
		timeout: timeout,
	}
}

// NewRepoAddPushMirrorParamsWithContext creates a new RepoAddPushMirrorParams object
// with the ability to set a context for a request.
func NewRepoAddPushMirrorParamsWithContext(ctx context.Context) *RepoAddPushMirrorParams {
	return &RepoAddPushMirrorParams{
		Context: ctx,
	}
}

// NewRepoAddPushMirrorParamsWithHTTPClient creates a new RepoAddPushMirrorParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoAddPushMirrorParamsWithHTTPClient(client *http.Client) *RepoAddPushMirrorParams {
	return &RepoAddPushMirrorParams{
		HTTPClient: client,
	}
}

/*
RepoAddPushMirrorParams contains all the parameters to send to the API endpoint

	for the repo add push mirror operation.

	Typically these are written to a http.Request.
*/
type RepoAddPushMirrorParams struct {

	// Body.
	Body *models.CreatePushMirrorOption

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo add push mirror params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoAddPushMirrorParams) WithDefaults() *RepoAddPushMirrorParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo add push mirror params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoAddPushMirrorParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo add push mirror params
func (o *RepoAddPushMirrorParams) WithTimeout(timeout time.Duration) *RepoAddPushMirrorParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo add push mirror params
func (o *RepoAddPushMirrorParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo add push mirror params
func (o *RepoAddPushMirrorParams) WithContext(ctx context.Context) *RepoAddPushMirrorParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo add push mirror params
func (o *RepoAddPushMirrorParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo add push mirror params
func (o *RepoAddPushMirrorParams) WithHTTPClient(client *http.Client) *RepoAddPushMirrorParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo add push mirror params
func (o *RepoAddPushMirrorParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo add push mirror params
func (o *RepoAddPushMirrorParams) WithBody(body *models.CreatePushMirrorOption) *RepoAddPushMirrorParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo add push mirror params
func (o *RepoAddPushMirrorParams) SetBody(body *models.CreatePushMirrorOption) {
	o.Body = body
}

// WithOwner adds the owner to the repo add push mirror params
func (o *RepoAddPushMirrorParams) WithOwner(owner string) *RepoAddPushMirrorParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo add push mirror params
func (o *RepoAddPushMirrorParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo add push mirror params
func (o *RepoAddPushMirrorParams) WithRepo(repo string) *RepoAddPushMirrorParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo add push mirror params
func (o *RepoAddPushMirrorParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoAddPushMirrorParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
