// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoCompareDiffParams creates a new RepoCompareDiffParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoCompareDiffParams() *RepoCompareDiffParams {
	return &RepoCompareDiffParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoCompareDiffParamsWithTimeout creates a new RepoCompareDiffParams object
// with the ability to set a timeout on a request.
func NewRepoCompareDiffParamsWithTimeout(timeout time.Duration) *RepoCompareDiffParams {
	return &RepoCompareDiffParams{
		timeout: timeout,
	}
}

// NewRepoCompareDiffParamsWithContext creates a new RepoCompareDiffParams object
// with the ability to set a context for a request.
func NewRepoCompareDiffParamsWithContext(ctx context.Context) *RepoCompareDiffParams {
	return &RepoCompareDiffParams{
		Context: ctx,
	}
}

// NewRepoCompareDiffParamsWithHTTPClient creates a new RepoCompareDiffParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoCompareDiffParamsWithHTTPClient(client *http.Client) *RepoCompareDiffParams {
	return &RepoCompareDiffParams{
		HTTPClient: client,
	}
}

/*
RepoCompareDiffParams contains all the parameters to send to the API endpoint

	for the repo compare diff operation.

	Typically these are written to a http.Request.
*/
type RepoCompareDiffParams struct {

	/* Basehead.

	   compare two branches or commits
	*/
	Basehead string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo compare diff params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCompareDiffParams) WithDefaults() *RepoCompareDiffParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo compare diff params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCompareDiffParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo compare diff params
func (o *RepoCompareDiffParams) WithTimeout(timeout time.Duration) *RepoCompareDiffParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo compare diff params
func (o *RepoCompareDiffParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo compare diff params
func (o *RepoCompareDiffParams) WithContext(ctx context.Context) *RepoCompareDiffParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo compare diff params
func (o *RepoCompareDiffParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo compare diff params
func (o *RepoCompareDiffParams) WithHTTPClient(client *http.Client) *RepoCompareDiffParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo compare diff params
func (o *RepoCompareDiffParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBasehead adds the basehead to the repo compare diff params
func (o *RepoCompareDiffParams) WithBasehead(basehead string) *RepoCompareDiffParams {
	o.SetBasehead(basehead)
	return o
}

// SetBasehead adds the basehead to the repo compare diff params
func (o *RepoCompareDiffParams) SetBasehead(basehead string) {
	o.Basehead = basehead
}

// WithOwner adds the owner to the repo compare diff params
func (o *RepoCompareDiffParams) WithOwner(owner string) *RepoCompareDiffParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo compare diff params
func (o *RepoCompareDiffParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo compare diff params
func (o *RepoCompareDiffParams) WithRepo(repo string) *RepoCompareDiffParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo compare diff params
func (o *RepoCompareDiffParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoCompareDiffParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param basehead
	if err := r.SetPathParam("basehead", o.Basehead); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
