// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoCreateKeyParams creates a new RepoCreateKeyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoCreateKeyParams() *RepoCreateKeyParams {
	return &RepoCreateKeyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoCreateKeyParamsWithTimeout creates a new RepoCreateKeyParams object
// with the ability to set a timeout on a request.
func NewRepoCreateKeyParamsWithTimeout(timeout time.Duration) *RepoCreateKeyParams {
	return &RepoCreateKeyParams{
		timeout: timeout,
	}
}

// NewRepoCreateKeyParamsWithContext creates a new RepoCreateKeyParams object
// with the ability to set a context for a request.
func NewRepoCreateKeyParamsWithContext(ctx context.Context) *RepoCreateKeyParams {
	return &RepoCreateKeyParams{
		Context: ctx,
	}
}

// NewRepoCreateKeyParamsWithHTTPClient creates a new RepoCreateKeyParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoCreateKeyParamsWithHTTPClient(client *http.Client) *RepoCreateKeyParams {
	return &RepoCreateKeyParams{
		HTTPClient: client,
	}
}

/*
RepoCreateKeyParams contains all the parameters to send to the API endpoint

	for the repo create key operation.

	Typically these are written to a http.Request.
*/
type RepoCreateKeyParams struct {

	// Body.
	Body *models.CreateKeyOption

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo create key params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCreateKeyParams) WithDefaults() *RepoCreateKeyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo create key params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCreateKeyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo create key params
func (o *RepoCreateKeyParams) WithTimeout(timeout time.Duration) *RepoCreateKeyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo create key params
func (o *RepoCreateKeyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo create key params
func (o *RepoCreateKeyParams) WithContext(ctx context.Context) *RepoCreateKeyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo create key params
func (o *RepoCreateKeyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo create key params
func (o *RepoCreateKeyParams) WithHTTPClient(client *http.Client) *RepoCreateKeyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo create key params
func (o *RepoCreateKeyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo create key params
func (o *RepoCreateKeyParams) WithBody(body *models.CreateKeyOption) *RepoCreateKeyParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo create key params
func (o *RepoCreateKeyParams) SetBody(body *models.CreateKeyOption) {
	o.Body = body
}

// WithOwner adds the owner to the repo create key params
func (o *RepoCreateKeyParams) WithOwner(owner string) *RepoCreateKeyParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo create key params
func (o *RepoCreateKeyParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo create key params
func (o *RepoCreateKeyParams) WithRepo(repo string) *RepoCreateKeyParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo create key params
func (o *RepoCreateKeyParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoCreateKeyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
