// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoDismissPullReviewParams creates a new RepoDismissPullReviewParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDismissPullReviewParams() *RepoDismissPullReviewParams {
	return &RepoDismissPullReviewParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDismissPullReviewParamsWithTimeout creates a new RepoDismissPullReviewParams object
// with the ability to set a timeout on a request.
func NewRepoDismissPullReviewParamsWithTimeout(timeout time.Duration) *RepoDismissPullReviewParams {
	return &RepoDismissPullReviewParams{
		timeout: timeout,
	}
}

// NewRepoDismissPullReviewParamsWithContext creates a new RepoDismissPullReviewParams object
// with the ability to set a context for a request.
func NewRepoDismissPullReviewParamsWithContext(ctx context.Context) *RepoDismissPullReviewParams {
	return &RepoDismissPullReviewParams{
		Context: ctx,
	}
}

// NewRepoDismissPullReviewParamsWithHTTPClient creates a new RepoDismissPullReviewParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDismissPullReviewParamsWithHTTPClient(client *http.Client) *RepoDismissPullReviewParams {
	return &RepoDismissPullReviewParams{
		HTTPClient: client,
	}
}

/*
RepoDismissPullReviewParams contains all the parameters to send to the API endpoint

	for the repo dismiss pull review operation.

	Typically these are written to a http.Request.
*/
type RepoDismissPullReviewParams struct {

	// Body.
	Body *models.DismissPullReviewOptions

	/* ID.

	   id of the review

	   Format: int64
	*/
	ID int64

	/* Index.

	   index of the pull request

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo dismiss pull review params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDismissPullReviewParams) WithDefaults() *RepoDismissPullReviewParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo dismiss pull review params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDismissPullReviewParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) WithTimeout(timeout time.Duration) *RepoDismissPullReviewParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) WithContext(ctx context.Context) *RepoDismissPullReviewParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) WithHTTPClient(client *http.Client) *RepoDismissPullReviewParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) WithBody(body *models.DismissPullReviewOptions) *RepoDismissPullReviewParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) SetBody(body *models.DismissPullReviewOptions) {
	o.Body = body
}

// WithID adds the id to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) WithID(id int64) *RepoDismissPullReviewParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) SetID(id int64) {
	o.ID = id
}

// WithIndex adds the index to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) WithIndex(index int64) *RepoDismissPullReviewParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) WithOwner(owner string) *RepoDismissPullReviewParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) WithRepo(repo string) *RepoDismissPullReviewParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo dismiss pull review params
func (o *RepoDismissPullReviewParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDismissPullReviewParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
