// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoGetKeyParams creates a new RepoGetKeyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoGetKeyParams() *RepoGetKeyParams {
	return &RepoGetKeyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoGetKeyParamsWithTimeout creates a new RepoGetKeyParams object
// with the ability to set a timeout on a request.
func NewRepoGetKeyParamsWithTimeout(timeout time.Duration) *RepoGetKeyParams {
	return &RepoGetKeyParams{
		timeout: timeout,
	}
}

// NewRepoGetKeyParamsWithContext creates a new RepoGetKeyParams object
// with the ability to set a context for a request.
func NewRepoGetKeyParamsWithContext(ctx context.Context) *RepoGetKeyParams {
	return &RepoGetKeyParams{
		Context: ctx,
	}
}

// NewRepoGetKeyParamsWithHTTPClient creates a new RepoGetKeyParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoGetKeyParamsWithHTTPClient(client *http.Client) *RepoGetKeyParams {
	return &RepoGetKeyParams{
		HTTPClient: client,
	}
}

/*
RepoGetKeyParams contains all the parameters to send to the API endpoint

	for the repo get key operation.

	Typically these are written to a http.Request.
*/
type RepoGetKeyParams struct {

	/* ID.

	   id of the key to get

	   Format: int64
	*/
	ID int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo get key params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetKeyParams) WithDefaults() *RepoGetKeyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo get key params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetKeyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo get key params
func (o *RepoGetKeyParams) WithTimeout(timeout time.Duration) *RepoGetKeyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo get key params
func (o *RepoGetKeyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo get key params
func (o *RepoGetKeyParams) WithContext(ctx context.Context) *RepoGetKeyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo get key params
func (o *RepoGetKeyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo get key params
func (o *RepoGetKeyParams) WithHTTPClient(client *http.Client) *RepoGetKeyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo get key params
func (o *RepoGetKeyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the repo get key params
func (o *RepoGetKeyParams) WithID(id int64) *RepoGetKeyParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo get key params
func (o *RepoGetKeyParams) SetID(id int64) {
	o.ID = id
}

// WithOwner adds the owner to the repo get key params
func (o *RepoGetKeyParams) WithOwner(owner string) *RepoGetKeyParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo get key params
func (o *RepoGetKeyParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo get key params
func (o *RepoGetKeyParams) WithRepo(repo string) *RepoGetKeyParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo get key params
func (o *RepoGetKeyParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoGetKeyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
