// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoGetRepoPermissionsParams creates a new RepoGetRepoPermissionsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoGetRepoPermissionsParams() *RepoGetRepoPermissionsParams {
	return &RepoGetRepoPermissionsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoGetRepoPermissionsParamsWithTimeout creates a new RepoGetRepoPermissionsParams object
// with the ability to set a timeout on a request.
func NewRepoGetRepoPermissionsParamsWithTimeout(timeout time.Duration) *RepoGetRepoPermissionsParams {
	return &RepoGetRepoPermissionsParams{
		timeout: timeout,
	}
}

// NewRepoGetRepoPermissionsParamsWithContext creates a new RepoGetRepoPermissionsParams object
// with the ability to set a context for a request.
func NewRepoGetRepoPermissionsParamsWithContext(ctx context.Context) *RepoGetRepoPermissionsParams {
	return &RepoGetRepoPermissionsParams{
		Context: ctx,
	}
}

// NewRepoGetRepoPermissionsParamsWithHTTPClient creates a new RepoGetRepoPermissionsParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoGetRepoPermissionsParamsWithHTTPClient(client *http.Client) *RepoGetRepoPermissionsParams {
	return &RepoGetRepoPermissionsParams{
		HTTPClient: client,
	}
}

/*
RepoGetRepoPermissionsParams contains all the parameters to send to the API endpoint

	for the repo get repo permissions operation.

	Typically these are written to a http.Request.
*/
type RepoGetRepoPermissionsParams struct {

	/* Collaborator.

	   username of the collaborator
	*/
	Collaborator string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo get repo permissions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetRepoPermissionsParams) WithDefaults() *RepoGetRepoPermissionsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo get repo permissions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetRepoPermissionsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) WithTimeout(timeout time.Duration) *RepoGetRepoPermissionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) WithContext(ctx context.Context) *RepoGetRepoPermissionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) WithHTTPClient(client *http.Client) *RepoGetRepoPermissionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCollaborator adds the collaborator to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) WithCollaborator(collaborator string) *RepoGetRepoPermissionsParams {
	o.SetCollaborator(collaborator)
	return o
}

// SetCollaborator adds the collaborator to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) SetCollaborator(collaborator string) {
	o.Collaborator = collaborator
}

// WithOwner adds the owner to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) WithOwner(owner string) *RepoGetRepoPermissionsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) WithRepo(repo string) *RepoGetRepoPermissionsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo get repo permissions params
func (o *RepoGetRepoPermissionsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoGetRepoPermissionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param collaborator
	if err := r.SetPathParam("collaborator", o.Collaborator); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
