// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// RepoGetReader is a Reader for the RepoGet structure.
type RepoGetReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *RepoGetReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewRepoGetOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewRepoGetNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /repos/{owner}/{repo}] repoGet", response, response.Code())
	}
}

// NewRepoGetOK creates a RepoGetOK with default headers values
func NewRepoGetOK() *RepoGetOK {
	return &RepoGetOK{}
}

/*
RepoGetOK describes a response with status code 200, with default header values.

Repository
*/
type RepoGetOK struct {
	Payload *models.Repository
}

// IsSuccess returns true when this repo get o k response has a 2xx status code
func (o *RepoGetOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this repo get o k response has a 3xx status code
func (o *RepoGetOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo get o k response has a 4xx status code
func (o *RepoGetOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this repo get o k response has a 5xx status code
func (o *RepoGetOK) IsServerError() bool {
	return false
}

// IsCode returns true when this repo get o k response a status code equal to that given
func (o *RepoGetOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the repo get o k response
func (o *RepoGetOK) Code() int {
	return 200
}

func (o *RepoGetOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}][%d] repoGetOK %s", 200, payload)
}

func (o *RepoGetOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}][%d] repoGetOK %s", 200, payload)
}

func (o *RepoGetOK) GetPayload() *models.Repository {
	return o.Payload
}

func (o *RepoGetOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Repository)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRepoGetNotFound creates a RepoGetNotFound with default headers values
func NewRepoGetNotFound() *RepoGetNotFound {
	return &RepoGetNotFound{}
}

/*
RepoGetNotFound describes a response with status code 404, with default header values.

APINotFound is a not found empty response
*/
type RepoGetNotFound struct {
}

// IsSuccess returns true when this repo get not found response has a 2xx status code
func (o *RepoGetNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this repo get not found response has a 3xx status code
func (o *RepoGetNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo get not found response has a 4xx status code
func (o *RepoGetNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this repo get not found response has a 5xx status code
func (o *RepoGetNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this repo get not found response a status code equal to that given
func (o *RepoGetNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the repo get not found response
func (o *RepoGetNotFound) Code() int {
	return 404
}

func (o *RepoGetNotFound) Error() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}][%d] repoGetNotFound", 404)
}

func (o *RepoGetNotFound) String() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}][%d] repoGetNotFound", 404)
}

func (o *RepoGetNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
