// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoListAllGitRefsParams creates a new RepoListAllGitRefsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoListAllGitRefsParams() *RepoListAllGitRefsParams {
	return &RepoListAllGitRefsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoListAllGitRefsParamsWithTimeout creates a new RepoListAllGitRefsParams object
// with the ability to set a timeout on a request.
func NewRepoListAllGitRefsParamsWithTimeout(timeout time.Duration) *RepoListAllGitRefsParams {
	return &RepoListAllGitRefsParams{
		timeout: timeout,
	}
}

// NewRepoListAllGitRefsParamsWithContext creates a new RepoListAllGitRefsParams object
// with the ability to set a context for a request.
func NewRepoListAllGitRefsParamsWithContext(ctx context.Context) *RepoListAllGitRefsParams {
	return &RepoListAllGitRefsParams{
		Context: ctx,
	}
}

// NewRepoListAllGitRefsParamsWithHTTPClient creates a new RepoListAllGitRefsParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoListAllGitRefsParamsWithHTTPClient(client *http.Client) *RepoListAllGitRefsParams {
	return &RepoListAllGitRefsParams{
		HTTPClient: client,
	}
}

/*
RepoListAllGitRefsParams contains all the parameters to send to the API endpoint

	for the repo list all git refs operation.

	Typically these are written to a http.Request.
*/
type RepoListAllGitRefsParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo list all git refs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoListAllGitRefsParams) WithDefaults() *RepoListAllGitRefsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo list all git refs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoListAllGitRefsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo list all git refs params
func (o *RepoListAllGitRefsParams) WithTimeout(timeout time.Duration) *RepoListAllGitRefsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo list all git refs params
func (o *RepoListAllGitRefsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo list all git refs params
func (o *RepoListAllGitRefsParams) WithContext(ctx context.Context) *RepoListAllGitRefsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo list all git refs params
func (o *RepoListAllGitRefsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo list all git refs params
func (o *RepoListAllGitRefsParams) WithHTTPClient(client *http.Client) *RepoListAllGitRefsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo list all git refs params
func (o *RepoListAllGitRefsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo list all git refs params
func (o *RepoListAllGitRefsParams) WithOwner(owner string) *RepoListAllGitRefsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo list all git refs params
func (o *RepoListAllGitRefsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo list all git refs params
func (o *RepoListAllGitRefsParams) WithRepo(repo string) *RepoListAllGitRefsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo list all git refs params
func (o *RepoListAllGitRefsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoListAllGitRefsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
