// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// RepoListStargazersReader is a Reader for the RepoListStargazers structure.
type RepoListStargazersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *RepoListStargazersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewRepoListStargazersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewRepoListStargazersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /repos/{owner}/{repo}/stargazers] repoListStargazers", response, response.Code())
	}
}

// NewRepoListStargazersOK creates a RepoListStargazersOK with default headers values
func NewRepoListStargazersOK() *RepoListStargazersOK {
	return &RepoListStargazersOK{}
}

/*
RepoListStargazersOK describes a response with status code 200, with default header values.

UserList
*/
type RepoListStargazersOK struct {
	Payload []*models.User
}

// IsSuccess returns true when this repo list stargazers o k response has a 2xx status code
func (o *RepoListStargazersOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this repo list stargazers o k response has a 3xx status code
func (o *RepoListStargazersOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo list stargazers o k response has a 4xx status code
func (o *RepoListStargazersOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this repo list stargazers o k response has a 5xx status code
func (o *RepoListStargazersOK) IsServerError() bool {
	return false
}

// IsCode returns true when this repo list stargazers o k response a status code equal to that given
func (o *RepoListStargazersOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the repo list stargazers o k response
func (o *RepoListStargazersOK) Code() int {
	return 200
}

func (o *RepoListStargazersOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/stargazers][%d] repoListStargazersOK %s", 200, payload)
}

func (o *RepoListStargazersOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/stargazers][%d] repoListStargazersOK %s", 200, payload)
}

func (o *RepoListStargazersOK) GetPayload() []*models.User {
	return o.Payload
}

func (o *RepoListStargazersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRepoListStargazersNotFound creates a RepoListStargazersNotFound with default headers values
func NewRepoListStargazersNotFound() *RepoListStargazersNotFound {
	return &RepoListStargazersNotFound{}
}

/*
RepoListStargazersNotFound describes a response with status code 404, with default header values.

APINotFound is a not found empty response
*/
type RepoListStargazersNotFound struct {
}

// IsSuccess returns true when this repo list stargazers not found response has a 2xx status code
func (o *RepoListStargazersNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this repo list stargazers not found response has a 3xx status code
func (o *RepoListStargazersNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo list stargazers not found response has a 4xx status code
func (o *RepoListStargazersNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this repo list stargazers not found response has a 5xx status code
func (o *RepoListStargazersNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this repo list stargazers not found response a status code equal to that given
func (o *RepoListStargazersNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the repo list stargazers not found response
func (o *RepoListStargazersNotFound) Code() int {
	return 404
}

func (o *RepoListStargazersNotFound) Error() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/stargazers][%d] repoListStargazersNotFound", 404)
}

func (o *RepoListStargazersNotFound) String() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/stargazers][%d] repoListStargazersNotFound", 404)
}

func (o *RepoListStargazersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
