// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// RepoListTopicsReader is a Reader for the RepoListTopics structure.
type RepoListTopicsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *RepoListTopicsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewRepoListTopicsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewRepoListTopicsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /repos/{owner}/{repo}/topics] repoListTopics", response, response.Code())
	}
}

// NewRepoListTopicsOK creates a RepoListTopicsOK with default headers values
func NewRepoListTopicsOK() *RepoListTopicsOK {
	return &RepoListTopicsOK{}
}

/*
RepoListTopicsOK describes a response with status code 200, with default header values.

TopicNames
*/
type RepoListTopicsOK struct {
	Payload *models.TopicName
}

// IsSuccess returns true when this repo list topics o k response has a 2xx status code
func (o *RepoListTopicsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this repo list topics o k response has a 3xx status code
func (o *RepoListTopicsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo list topics o k response has a 4xx status code
func (o *RepoListTopicsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this repo list topics o k response has a 5xx status code
func (o *RepoListTopicsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this repo list topics o k response a status code equal to that given
func (o *RepoListTopicsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the repo list topics o k response
func (o *RepoListTopicsOK) Code() int {
	return 200
}

func (o *RepoListTopicsOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/topics][%d] repoListTopicsOK %s", 200, payload)
}

func (o *RepoListTopicsOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/topics][%d] repoListTopicsOK %s", 200, payload)
}

func (o *RepoListTopicsOK) GetPayload() *models.TopicName {
	return o.Payload
}

func (o *RepoListTopicsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.TopicName)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRepoListTopicsNotFound creates a RepoListTopicsNotFound with default headers values
func NewRepoListTopicsNotFound() *RepoListTopicsNotFound {
	return &RepoListTopicsNotFound{}
}

/*
RepoListTopicsNotFound describes a response with status code 404, with default header values.

APINotFound is a not found empty response
*/
type RepoListTopicsNotFound struct {
}

// IsSuccess returns true when this repo list topics not found response has a 2xx status code
func (o *RepoListTopicsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this repo list topics not found response has a 3xx status code
func (o *RepoListTopicsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo list topics not found response has a 4xx status code
func (o *RepoListTopicsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this repo list topics not found response has a 5xx status code
func (o *RepoListTopicsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this repo list topics not found response a status code equal to that given
func (o *RepoListTopicsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the repo list topics not found response
func (o *RepoListTopicsNotFound) Code() int {
	return 404
}

func (o *RepoListTopicsNotFound) Error() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/topics][%d] repoListTopicsNotFound", 404)
}

func (o *RepoListTopicsNotFound) String() string {
	return fmt.Sprintf("[GET /repos/{owner}/{repo}/topics][%d] repoListTopicsNotFound", 404)
}

func (o *RepoListTopicsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
