// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoPullRequestIsMergedParams creates a new RepoPullRequestIsMergedParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoPullRequestIsMergedParams() *RepoPullRequestIsMergedParams {
	return &RepoPullRequestIsMergedParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoPullRequestIsMergedParamsWithTimeout creates a new RepoPullRequestIsMergedParams object
// with the ability to set a timeout on a request.
func NewRepoPullRequestIsMergedParamsWithTimeout(timeout time.Duration) *RepoPullRequestIsMergedParams {
	return &RepoPullRequestIsMergedParams{
		timeout: timeout,
	}
}

// NewRepoPullRequestIsMergedParamsWithContext creates a new RepoPullRequestIsMergedParams object
// with the ability to set a context for a request.
func NewRepoPullRequestIsMergedParamsWithContext(ctx context.Context) *RepoPullRequestIsMergedParams {
	return &RepoPullRequestIsMergedParams{
		Context: ctx,
	}
}

// NewRepoPullRequestIsMergedParamsWithHTTPClient creates a new RepoPullRequestIsMergedParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoPullRequestIsMergedParamsWithHTTPClient(client *http.Client) *RepoPullRequestIsMergedParams {
	return &RepoPullRequestIsMergedParams{
		HTTPClient: client,
	}
}

/*
RepoPullRequestIsMergedParams contains all the parameters to send to the API endpoint

	for the repo pull request is merged operation.

	Typically these are written to a http.Request.
*/
type RepoPullRequestIsMergedParams struct {

	/* Index.

	   index of the pull request

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo pull request is merged params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoPullRequestIsMergedParams) WithDefaults() *RepoPullRequestIsMergedParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo pull request is merged params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoPullRequestIsMergedParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) WithTimeout(timeout time.Duration) *RepoPullRequestIsMergedParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) WithContext(ctx context.Context) *RepoPullRequestIsMergedParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) WithHTTPClient(client *http.Client) *RepoPullRequestIsMergedParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) WithIndex(index int64) *RepoPullRequestIsMergedParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) WithOwner(owner string) *RepoPullRequestIsMergedParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) WithRepo(repo string) *RepoPullRequestIsMergedParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo pull request is merged params
func (o *RepoPullRequestIsMergedParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoPullRequestIsMergedParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
