// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoTestHookParams creates a new RepoTestHookParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoTestHookParams() *RepoTestHookParams {
	return &RepoTestHookParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoTestHookParamsWithTimeout creates a new RepoTestHookParams object
// with the ability to set a timeout on a request.
func NewRepoTestHookParamsWithTimeout(timeout time.Duration) *RepoTestHookParams {
	return &RepoTestHookParams{
		timeout: timeout,
	}
}

// NewRepoTestHookParamsWithContext creates a new RepoTestHookParams object
// with the ability to set a context for a request.
func NewRepoTestHookParamsWithContext(ctx context.Context) *RepoTestHookParams {
	return &RepoTestHookParams{
		Context: ctx,
	}
}

// NewRepoTestHookParamsWithHTTPClient creates a new RepoTestHookParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoTestHookParamsWithHTTPClient(client *http.Client) *RepoTestHookParams {
	return &RepoTestHookParams{
		HTTPClient: client,
	}
}

/*
RepoTestHookParams contains all the parameters to send to the API endpoint

	for the repo test hook operation.

	Typically these are written to a http.Request.
*/
type RepoTestHookParams struct {

	/* ID.

	   id of the hook to test

	   Format: int64
	*/
	ID int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Ref.

	   The name of the commit/branch/tag, indicates which commit will be loaded to the webhook payload.
	*/
	Ref *string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo test hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoTestHookParams) WithDefaults() *RepoTestHookParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo test hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoTestHookParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo test hook params
func (o *RepoTestHookParams) WithTimeout(timeout time.Duration) *RepoTestHookParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo test hook params
func (o *RepoTestHookParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo test hook params
func (o *RepoTestHookParams) WithContext(ctx context.Context) *RepoTestHookParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo test hook params
func (o *RepoTestHookParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo test hook params
func (o *RepoTestHookParams) WithHTTPClient(client *http.Client) *RepoTestHookParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo test hook params
func (o *RepoTestHookParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the repo test hook params
func (o *RepoTestHookParams) WithID(id int64) *RepoTestHookParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo test hook params
func (o *RepoTestHookParams) SetID(id int64) {
	o.ID = id
}

// WithOwner adds the owner to the repo test hook params
func (o *RepoTestHookParams) WithOwner(owner string) *RepoTestHookParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo test hook params
func (o *RepoTestHookParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRef adds the ref to the repo test hook params
func (o *RepoTestHookParams) WithRef(ref *string) *RepoTestHookParams {
	o.SetRef(ref)
	return o
}

// SetRef adds the ref to the repo test hook params
func (o *RepoTestHookParams) SetRef(ref *string) {
	o.Ref = ref
}

// WithRepo adds the repo to the repo test hook params
func (o *RepoTestHookParams) WithRepo(repo string) *RepoTestHookParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo test hook params
func (o *RepoTestHookParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoTestHookParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	if o.Ref != nil {

		// query param ref
		var qrRef string

		if o.Ref != nil {
			qrRef = *o.Ref
		}
		qRef := qrRef
		if qRef != "" {

			if err := r.SetQueryParam("ref", qRef); err != nil {
				return err
			}
		}
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
