// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoUnDismissPullReviewParams creates a new RepoUnDismissPullReviewParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoUnDismissPullReviewParams() *RepoUnDismissPullReviewParams {
	return &RepoUnDismissPullReviewParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoUnDismissPullReviewParamsWithTimeout creates a new RepoUnDismissPullReviewParams object
// with the ability to set a timeout on a request.
func NewRepoUnDismissPullReviewParamsWithTimeout(timeout time.Duration) *RepoUnDismissPullReviewParams {
	return &RepoUnDismissPullReviewParams{
		timeout: timeout,
	}
}

// NewRepoUnDismissPullReviewParamsWithContext creates a new RepoUnDismissPullReviewParams object
// with the ability to set a context for a request.
func NewRepoUnDismissPullReviewParamsWithContext(ctx context.Context) *RepoUnDismissPullReviewParams {
	return &RepoUnDismissPullReviewParams{
		Context: ctx,
	}
}

// NewRepoUnDismissPullReviewParamsWithHTTPClient creates a new RepoUnDismissPullReviewParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoUnDismissPullReviewParamsWithHTTPClient(client *http.Client) *RepoUnDismissPullReviewParams {
	return &RepoUnDismissPullReviewParams{
		HTTPClient: client,
	}
}

/*
RepoUnDismissPullReviewParams contains all the parameters to send to the API endpoint

	for the repo un dismiss pull review operation.

	Typically these are written to a http.Request.
*/
type RepoUnDismissPullReviewParams struct {

	/* ID.

	   id of the review

	   Format: int64
	*/
	ID int64

	/* Index.

	   index of the pull request

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo un dismiss pull review params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoUnDismissPullReviewParams) WithDefaults() *RepoUnDismissPullReviewParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo un dismiss pull review params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoUnDismissPullReviewParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) WithTimeout(timeout time.Duration) *RepoUnDismissPullReviewParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) WithContext(ctx context.Context) *RepoUnDismissPullReviewParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) WithHTTPClient(client *http.Client) *RepoUnDismissPullReviewParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) WithID(id int64) *RepoUnDismissPullReviewParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) SetID(id int64) {
	o.ID = id
}

// WithIndex adds the index to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) WithIndex(index int64) *RepoUnDismissPullReviewParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) WithOwner(owner string) *RepoUnDismissPullReviewParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) WithRepo(repo string) *RepoUnDismissPullReviewParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo un dismiss pull review params
func (o *RepoUnDismissPullReviewParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoUnDismissPullReviewParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
