// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoUpdateTopicsParams creates a new RepoUpdateTopicsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoUpdateTopicsParams() *RepoUpdateTopicsParams {
	return &RepoUpdateTopicsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoUpdateTopicsParamsWithTimeout creates a new RepoUpdateTopicsParams object
// with the ability to set a timeout on a request.
func NewRepoUpdateTopicsParamsWithTimeout(timeout time.Duration) *RepoUpdateTopicsParams {
	return &RepoUpdateTopicsParams{
		timeout: timeout,
	}
}

// NewRepoUpdateTopicsParamsWithContext creates a new RepoUpdateTopicsParams object
// with the ability to set a context for a request.
func NewRepoUpdateTopicsParamsWithContext(ctx context.Context) *RepoUpdateTopicsParams {
	return &RepoUpdateTopicsParams{
		Context: ctx,
	}
}

// NewRepoUpdateTopicsParamsWithHTTPClient creates a new RepoUpdateTopicsParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoUpdateTopicsParamsWithHTTPClient(client *http.Client) *RepoUpdateTopicsParams {
	return &RepoUpdateTopicsParams{
		HTTPClient: client,
	}
}

/*
RepoUpdateTopicsParams contains all the parameters to send to the API endpoint

	for the repo update topics operation.

	Typically these are written to a http.Request.
*/
type RepoUpdateTopicsParams struct {

	// Body.
	Body *models.RepoTopicOptions

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo update topics params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoUpdateTopicsParams) WithDefaults() *RepoUpdateTopicsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo update topics params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoUpdateTopicsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo update topics params
func (o *RepoUpdateTopicsParams) WithTimeout(timeout time.Duration) *RepoUpdateTopicsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo update topics params
func (o *RepoUpdateTopicsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo update topics params
func (o *RepoUpdateTopicsParams) WithContext(ctx context.Context) *RepoUpdateTopicsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo update topics params
func (o *RepoUpdateTopicsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo update topics params
func (o *RepoUpdateTopicsParams) WithHTTPClient(client *http.Client) *RepoUpdateTopicsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo update topics params
func (o *RepoUpdateTopicsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo update topics params
func (o *RepoUpdateTopicsParams) WithBody(body *models.RepoTopicOptions) *RepoUpdateTopicsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo update topics params
func (o *RepoUpdateTopicsParams) SetBody(body *models.RepoTopicOptions) {
	o.Body = body
}

// WithOwner adds the owner to the repo update topics params
func (o *RepoUpdateTopicsParams) WithOwner(owner string) *RepoUpdateTopicsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo update topics params
func (o *RepoUpdateTopicsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo update topics params
func (o *RepoUpdateTopicsParams) WithRepo(repo string) *RepoUpdateTopicsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo update topics params
func (o *RepoUpdateTopicsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoUpdateTopicsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
