// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewTopicSearchParams creates a new TopicSearchParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewTopicSearchParams() *TopicSearchParams {
	return &TopicSearchParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewTopicSearchParamsWithTimeout creates a new TopicSearchParams object
// with the ability to set a timeout on a request.
func NewTopicSearchParamsWithTimeout(timeout time.Duration) *TopicSearchParams {
	return &TopicSearchParams{
		timeout: timeout,
	}
}

// NewTopicSearchParamsWithContext creates a new TopicSearchParams object
// with the ability to set a context for a request.
func NewTopicSearchParamsWithContext(ctx context.Context) *TopicSearchParams {
	return &TopicSearchParams{
		Context: ctx,
	}
}

// NewTopicSearchParamsWithHTTPClient creates a new TopicSearchParams object
// with the ability to set a custom HTTPClient for a request.
func NewTopicSearchParamsWithHTTPClient(client *http.Client) *TopicSearchParams {
	return &TopicSearchParams{
		HTTPClient: client,
	}
}

/*
TopicSearchParams contains all the parameters to send to the API endpoint

	for the topic search operation.

	Typically these are written to a http.Request.
*/
type TopicSearchParams struct {

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	/* Q.

	   keywords to search
	*/
	Q string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the topic search params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TopicSearchParams) WithDefaults() *TopicSearchParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the topic search params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TopicSearchParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the topic search params
func (o *TopicSearchParams) WithTimeout(timeout time.Duration) *TopicSearchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the topic search params
func (o *TopicSearchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the topic search params
func (o *TopicSearchParams) WithContext(ctx context.Context) *TopicSearchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the topic search params
func (o *TopicSearchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the topic search params
func (o *TopicSearchParams) WithHTTPClient(client *http.Client) *TopicSearchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the topic search params
func (o *TopicSearchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the topic search params
func (o *TopicSearchParams) WithLimit(limit *int64) *TopicSearchParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the topic search params
func (o *TopicSearchParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithPage adds the page to the topic search params
func (o *TopicSearchParams) WithPage(page *int64) *TopicSearchParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the topic search params
func (o *TopicSearchParams) SetPage(page *int64) {
	o.Page = page
}

// WithQ adds the q to the topic search params
func (o *TopicSearchParams) WithQ(q string) *TopicSearchParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the topic search params
func (o *TopicSearchParams) SetQ(q string) {
	o.Q = q
}

// WriteToRequest writes these params to a swagger request
func (o *TopicSearchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	// query param q
	qrQ := o.Q
	qQ := qrQ
	if qQ != "" {

		if err := r.SetQueryParam("q", qQ); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
