// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUserCurrentPutSubscriptionParams creates a new UserCurrentPutSubscriptionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUserCurrentPutSubscriptionParams() *UserCurrentPutSubscriptionParams {
	return &UserCurrentPutSubscriptionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUserCurrentPutSubscriptionParamsWithTimeout creates a new UserCurrentPutSubscriptionParams object
// with the ability to set a timeout on a request.
func NewUserCurrentPutSubscriptionParamsWithTimeout(timeout time.Duration) *UserCurrentPutSubscriptionParams {
	return &UserCurrentPutSubscriptionParams{
		timeout: timeout,
	}
}

// NewUserCurrentPutSubscriptionParamsWithContext creates a new UserCurrentPutSubscriptionParams object
// with the ability to set a context for a request.
func NewUserCurrentPutSubscriptionParamsWithContext(ctx context.Context) *UserCurrentPutSubscriptionParams {
	return &UserCurrentPutSubscriptionParams{
		Context: ctx,
	}
}

// NewUserCurrentPutSubscriptionParamsWithHTTPClient creates a new UserCurrentPutSubscriptionParams object
// with the ability to set a custom HTTPClient for a request.
func NewUserCurrentPutSubscriptionParamsWithHTTPClient(client *http.Client) *UserCurrentPutSubscriptionParams {
	return &UserCurrentPutSubscriptionParams{
		HTTPClient: client,
	}
}

/*
UserCurrentPutSubscriptionParams contains all the parameters to send to the API endpoint

	for the user current put subscription operation.

	Typically these are written to a http.Request.
*/
type UserCurrentPutSubscriptionParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the user current put subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCurrentPutSubscriptionParams) WithDefaults() *UserCurrentPutSubscriptionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the user current put subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCurrentPutSubscriptionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the user current put subscription params
func (o *UserCurrentPutSubscriptionParams) WithTimeout(timeout time.Duration) *UserCurrentPutSubscriptionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the user current put subscription params
func (o *UserCurrentPutSubscriptionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the user current put subscription params
func (o *UserCurrentPutSubscriptionParams) WithContext(ctx context.Context) *UserCurrentPutSubscriptionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the user current put subscription params
func (o *UserCurrentPutSubscriptionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the user current put subscription params
func (o *UserCurrentPutSubscriptionParams) WithHTTPClient(client *http.Client) *UserCurrentPutSubscriptionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the user current put subscription params
func (o *UserCurrentPutSubscriptionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the user current put subscription params
func (o *UserCurrentPutSubscriptionParams) WithOwner(owner string) *UserCurrentPutSubscriptionParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the user current put subscription params
func (o *UserCurrentPutSubscriptionParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the user current put subscription params
func (o *UserCurrentPutSubscriptionParams) WithRepo(repo string) *UserCurrentPutSubscriptionParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the user current put subscription params
func (o *UserCurrentPutSubscriptionParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *UserCurrentPutSubscriptionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
