// Code generated by go-swagger; DO NOT EDIT.

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewUserCurrentListStarredParams creates a new UserCurrentListStarredParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUserCurrentListStarredParams() *UserCurrentListStarredParams {
	return &UserCurrentListStarredParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUserCurrentListStarredParamsWithTimeout creates a new UserCurrentListStarredParams object
// with the ability to set a timeout on a request.
func NewUserCurrentListStarredParamsWithTimeout(timeout time.Duration) *UserCurrentListStarredParams {
	return &UserCurrentListStarredParams{
		timeout: timeout,
	}
}

// NewUserCurrentListStarredParamsWithContext creates a new UserCurrentListStarredParams object
// with the ability to set a context for a request.
func NewUserCurrentListStarredParamsWithContext(ctx context.Context) *UserCurrentListStarredParams {
	return &UserCurrentListStarredParams{
		Context: ctx,
	}
}

// NewUserCurrentListStarredParamsWithHTTPClient creates a new UserCurrentListStarredParams object
// with the ability to set a custom HTTPClient for a request.
func NewUserCurrentListStarredParamsWithHTTPClient(client *http.Client) *UserCurrentListStarredParams {
	return &UserCurrentListStarredParams{
		HTTPClient: client,
	}
}

/*
UserCurrentListStarredParams contains all the parameters to send to the API endpoint

	for the user current list starred operation.

	Typically these are written to a http.Request.
*/
type UserCurrentListStarredParams struct {

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the user current list starred params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCurrentListStarredParams) WithDefaults() *UserCurrentListStarredParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the user current list starred params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCurrentListStarredParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the user current list starred params
func (o *UserCurrentListStarredParams) WithTimeout(timeout time.Duration) *UserCurrentListStarredParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the user current list starred params
func (o *UserCurrentListStarredParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the user current list starred params
func (o *UserCurrentListStarredParams) WithContext(ctx context.Context) *UserCurrentListStarredParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the user current list starred params
func (o *UserCurrentListStarredParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the user current list starred params
func (o *UserCurrentListStarredParams) WithHTTPClient(client *http.Client) *UserCurrentListStarredParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the user current list starred params
func (o *UserCurrentListStarredParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the user current list starred params
func (o *UserCurrentListStarredParams) WithLimit(limit *int64) *UserCurrentListStarredParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the user current list starred params
func (o *UserCurrentListStarredParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithPage adds the page to the user current list starred params
func (o *UserCurrentListStarredParams) WithPage(page *int64) *UserCurrentListStarredParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the user current list starred params
func (o *UserCurrentListStarredParams) SetPage(page *int64) {
	o.Page = page
}

// WriteToRequest writes these params to a swagger request
func (o *UserCurrentListStarredParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
