// Code generated by go-swagger; DO NOT EDIT.

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUserCurrentPutStarParams creates a new UserCurrentPutStarParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUserCurrentPutStarParams() *UserCurrentPutStarParams {
	return &UserCurrentPutStarParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUserCurrentPutStarParamsWithTimeout creates a new UserCurrentPutStarParams object
// with the ability to set a timeout on a request.
func NewUserCurrentPutStarParamsWithTimeout(timeout time.Duration) *UserCurrentPutStarParams {
	return &UserCurrentPutStarParams{
		timeout: timeout,
	}
}

// NewUserCurrentPutStarParamsWithContext creates a new UserCurrentPutStarParams object
// with the ability to set a context for a request.
func NewUserCurrentPutStarParamsWithContext(ctx context.Context) *UserCurrentPutStarParams {
	return &UserCurrentPutStarParams{
		Context: ctx,
	}
}

// NewUserCurrentPutStarParamsWithHTTPClient creates a new UserCurrentPutStarParams object
// with the ability to set a custom HTTPClient for a request.
func NewUserCurrentPutStarParamsWithHTTPClient(client *http.Client) *UserCurrentPutStarParams {
	return &UserCurrentPutStarParams{
		HTTPClient: client,
	}
}

/*
UserCurrentPutStarParams contains all the parameters to send to the API endpoint

	for the user current put star operation.

	Typically these are written to a http.Request.
*/
type UserCurrentPutStarParams struct {

	/* Owner.

	   owner of the repo to star
	*/
	Owner string

	/* Repo.

	   name of the repo to star
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the user current put star params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCurrentPutStarParams) WithDefaults() *UserCurrentPutStarParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the user current put star params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCurrentPutStarParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the user current put star params
func (o *UserCurrentPutStarParams) WithTimeout(timeout time.Duration) *UserCurrentPutStarParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the user current put star params
func (o *UserCurrentPutStarParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the user current put star params
func (o *UserCurrentPutStarParams) WithContext(ctx context.Context) *UserCurrentPutStarParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the user current put star params
func (o *UserCurrentPutStarParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the user current put star params
func (o *UserCurrentPutStarParams) WithHTTPClient(client *http.Client) *UserCurrentPutStarParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the user current put star params
func (o *UserCurrentPutStarParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the user current put star params
func (o *UserCurrentPutStarParams) WithOwner(owner string) *UserCurrentPutStarParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the user current put star params
func (o *UserCurrentPutStarParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the user current put star params
func (o *UserCurrentPutStarParams) WithRepo(repo string) *UserCurrentPutStarParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the user current put star params
func (o *UserCurrentPutStarParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *UserCurrentPutStarParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
